package org.eclipse.lsat.activity.teditor.parser.antlr.internal;

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.eclipse.lsat.activity.teditor.services.ActivityGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalActivityParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_INT", "RULE_ID", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'import'", "'activity'", "'{'", "'prerequisites'", "'}'", "'actions'", "'action flow'", "'.'", "'at'", "':'", "'passive'", "'claim'", "'release'", "'raise'", "'require'", "'move'", "'passing'", "'to'", "'continuing'", "'for'", "'with speed profile'", "'['", "'~'", "']'", "'->'", "'|'", "'ASAP'", "'ALAP'"
    };
    public static final int RULE_STRING=4;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__38=38;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=6;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=5;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalActivityParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalActivityParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalActivityParser.tokenNames; }
    public String getGrammarFileName() { return "InternalActivity.g"; }



     	private ActivityGrammarAccess grammarAccess;

        public InternalActivityParser(TokenStream input, ActivityGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }

        @Override
        protected String getFirstRuleName() {
        	return "ActivitySet";
       	}

       	@Override
       	protected ActivityGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}




    // $ANTLR start "entryRuleActivitySet"
    // InternalActivity.g:73:1: entryRuleActivitySet returns [EObject current=null] : iv_ruleActivitySet= ruleActivitySet EOF ;
    public final EObject entryRuleActivitySet() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleActivitySet = null;


        try {
            // InternalActivity.g:73:52: (iv_ruleActivitySet= ruleActivitySet EOF )
            // InternalActivity.g:74:2: iv_ruleActivitySet= ruleActivitySet EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getActivitySetRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleActivitySet=ruleActivitySet();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleActivitySet; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleActivitySet"


    // $ANTLR start "ruleActivitySet"
    // InternalActivity.g:80:1: ruleActivitySet returns [EObject current=null] : ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_activities_2_0= ruleActivity ) )* ) ;
    public final EObject ruleActivitySet() throws RecognitionException {
        EObject current = null;

        EObject lv_imports_1_0 = null;

        EObject lv_activities_2_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:86:2: ( ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_activities_2_0= ruleActivity ) )* ) )
            // InternalActivity.g:87:2: ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_activities_2_0= ruleActivity ) )* )
            {
            // InternalActivity.g:87:2: ( () ( (lv_imports_1_0= ruleImport ) )* ( (lv_activities_2_0= ruleActivity ) )* )
            // InternalActivity.g:88:3: () ( (lv_imports_1_0= ruleImport ) )* ( (lv_activities_2_0= ruleActivity ) )*
            {
            // InternalActivity.g:88:3: ()
            // InternalActivity.g:89:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getActivitySetAccess().getActivitySetAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:95:3: ( (lv_imports_1_0= ruleImport ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==11) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // InternalActivity.g:96:4: (lv_imports_1_0= ruleImport )
            	    {
            	    // InternalActivity.g:96:4: (lv_imports_1_0= ruleImport )
            	    // InternalActivity.g:97:5: lv_imports_1_0= ruleImport
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivitySetAccess().getImportsImportParserRuleCall_1_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_3);
            	    lv_imports_1_0=ruleImport();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivitySetRule());
            	      					}
            	      					add(
            	      						current,
            	      						"imports",
            	      						lv_imports_1_0,
            	      						"org.eclipse.lsat.activity.teditor.Activity.Import");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            // InternalActivity.g:114:3: ( (lv_activities_2_0= ruleActivity ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==12) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // InternalActivity.g:115:4: (lv_activities_2_0= ruleActivity )
            	    {
            	    // InternalActivity.g:115:4: (lv_activities_2_0= ruleActivity )
            	    // InternalActivity.g:116:5: lv_activities_2_0= ruleActivity
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivitySetAccess().getActivitiesActivityParserRuleCall_2_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_4);
            	    lv_activities_2_0=ruleActivity();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivitySetRule());
            	      					}
            	      					add(
            	      						current,
            	      						"activities",
            	      						lv_activities_2_0,
            	      						"org.eclipse.lsat.activity.teditor.Activity.Activity");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleActivitySet"


    // $ANTLR start "entryRuleImport"
    // InternalActivity.g:137:1: entryRuleImport returns [EObject current=null] : iv_ruleImport= ruleImport EOF ;
    public final EObject entryRuleImport() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleImport = null;


        try {
            // InternalActivity.g:137:47: (iv_ruleImport= ruleImport EOF )
            // InternalActivity.g:138:2: iv_ruleImport= ruleImport EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getImportRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleImport=ruleImport();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleImport; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalActivity.g:144:1: ruleImport returns [EObject current=null] : (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) ;
    public final EObject ruleImport() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_importURI_1_0=null;


        	enterRule();

        try {
            // InternalActivity.g:150:2: ( (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) ) )
            // InternalActivity.g:151:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            {
            // InternalActivity.g:151:2: (otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) ) )
            // InternalActivity.g:152:3: otherlv_0= 'import' ( (lv_importURI_1_0= RULE_STRING ) )
            {
            otherlv_0=(Token)match(input,11,FOLLOW_5); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getImportAccess().getImportKeyword_0());
              		
            }
            // InternalActivity.g:156:3: ( (lv_importURI_1_0= RULE_STRING ) )
            // InternalActivity.g:157:4: (lv_importURI_1_0= RULE_STRING )
            {
            // InternalActivity.g:157:4: (lv_importURI_1_0= RULE_STRING )
            // InternalActivity.g:158:5: lv_importURI_1_0= RULE_STRING
            {
            lv_importURI_1_0=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(lv_importURI_1_0, grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0());
              				
            }
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getImportRule());
              					}
              					setWithLastConsumed(
              						current,
              						"importURI",
              						lv_importURI_1_0,
              						"org.eclipse.xtext.common.Terminals.STRING");
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRuleActivity"
    // InternalActivity.g:178:1: entryRuleActivity returns [EObject current=null] : iv_ruleActivity= ruleActivity EOF ;
    public final EObject entryRuleActivity() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleActivity = null;


        try {
            // InternalActivity.g:178:49: (iv_ruleActivity= ruleActivity EOF )
            // InternalActivity.g:179:2: iv_ruleActivity= ruleActivity EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getActivityRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleActivity=ruleActivity();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleActivity; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleActivity"


    // $ANTLR start "ruleActivity"
    // InternalActivity.g:185:1: ruleActivity returns [EObject current=null] : (otherlv_0= 'activity' ( (lv_name_1_0= ruleIID ) ) otherlv_2= '{' (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )? otherlv_7= 'actions' otherlv_8= '{' ( (lv_nodes_9_0= ruleNode ) )* otherlv_10= '}' otherlv_11= 'action flow' otherlv_12= '{' ( (lv_edges_13_0= ruleEdges ) )* otherlv_14= '}' otherlv_15= '}' ) ;
    public final EObject ruleActivity() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_prerequisites_5_0 = null;

        EObject lv_nodes_9_0 = null;

        EObject lv_edges_13_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:191:2: ( (otherlv_0= 'activity' ( (lv_name_1_0= ruleIID ) ) otherlv_2= '{' (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )? otherlv_7= 'actions' otherlv_8= '{' ( (lv_nodes_9_0= ruleNode ) )* otherlv_10= '}' otherlv_11= 'action flow' otherlv_12= '{' ( (lv_edges_13_0= ruleEdges ) )* otherlv_14= '}' otherlv_15= '}' ) )
            // InternalActivity.g:192:2: (otherlv_0= 'activity' ( (lv_name_1_0= ruleIID ) ) otherlv_2= '{' (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )? otherlv_7= 'actions' otherlv_8= '{' ( (lv_nodes_9_0= ruleNode ) )* otherlv_10= '}' otherlv_11= 'action flow' otherlv_12= '{' ( (lv_edges_13_0= ruleEdges ) )* otherlv_14= '}' otherlv_15= '}' )
            {
            // InternalActivity.g:192:2: (otherlv_0= 'activity' ( (lv_name_1_0= ruleIID ) ) otherlv_2= '{' (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )? otherlv_7= 'actions' otherlv_8= '{' ( (lv_nodes_9_0= ruleNode ) )* otherlv_10= '}' otherlv_11= 'action flow' otherlv_12= '{' ( (lv_edges_13_0= ruleEdges ) )* otherlv_14= '}' otherlv_15= '}' )
            // InternalActivity.g:193:3: otherlv_0= 'activity' ( (lv_name_1_0= ruleIID ) ) otherlv_2= '{' (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )? otherlv_7= 'actions' otherlv_8= '{' ( (lv_nodes_9_0= ruleNode ) )* otherlv_10= '}' otherlv_11= 'action flow' otherlv_12= '{' ( (lv_edges_13_0= ruleEdges ) )* otherlv_14= '}' otherlv_15= '}'
            {
            otherlv_0=(Token)match(input,12,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getActivityAccess().getActivityKeyword_0());
              		
            }
            // InternalActivity.g:197:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:198:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:198:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:199:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getActivityAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_7);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getActivityRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,13,FOLLOW_8); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_2());
              		
            }
            // InternalActivity.g:220:3: (otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}' )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==14) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // InternalActivity.g:221:4: otherlv_3= 'prerequisites' otherlv_4= '{' ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )* otherlv_6= '}'
                    {
                    otherlv_3=(Token)match(input,14,FOLLOW_7); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_3, grammarAccess.getActivityAccess().getPrerequisitesKeyword_3_0());
                      			
                    }
                    otherlv_4=(Token)match(input,13,FOLLOW_9); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_4, grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_3_1());
                      			
                    }
                    // InternalActivity.g:229:4: ( (lv_prerequisites_5_0= ruleLocationPrerequisite ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( ((LA3_0>=RULE_INT && LA3_0<=RULE_ID)) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // InternalActivity.g:230:5: (lv_prerequisites_5_0= ruleLocationPrerequisite )
                    	    {
                    	    // InternalActivity.g:230:5: (lv_prerequisites_5_0= ruleLocationPrerequisite )
                    	    // InternalActivity.g:231:6: lv_prerequisites_5_0= ruleLocationPrerequisite
                    	    {
                    	    if ( state.backtracking==0 ) {

                    	      						newCompositeNode(grammarAccess.getActivityAccess().getPrerequisitesLocationPrerequisiteParserRuleCall_3_2_0());
                    	      					
                    	    }
                    	    pushFollow(FOLLOW_9);
                    	    lv_prerequisites_5_0=ruleLocationPrerequisite();

                    	    state._fsp--;
                    	    if (state.failed) return current;
                    	    if ( state.backtracking==0 ) {

                    	      						if (current==null) {
                    	      							current = createModelElementForParent(grammarAccess.getActivityRule());
                    	      						}
                    	      						add(
                    	      							current,
                    	      							"prerequisites",
                    	      							lv_prerequisites_5_0,
                    	      							"org.eclipse.lsat.activity.teditor.Activity.LocationPrerequisite");
                    	      						afterParserOrEnumRuleCall();
                    	      					
                    	    }

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    otherlv_6=(Token)match(input,15,FOLLOW_10); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				newLeafNode(otherlv_6, grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_3_3());
                      			
                    }

                    }
                    break;

            }

            otherlv_7=(Token)match(input,16,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_7, grammarAccess.getActivityAccess().getActionsKeyword_4());
              		
            }
            otherlv_8=(Token)match(input,13,FOLLOW_9); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_8, grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_5());
              		
            }
            // InternalActivity.g:261:3: ( (lv_nodes_9_0= ruleNode ) )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( ((LA5_0>=RULE_INT && LA5_0<=RULE_ID)) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // InternalActivity.g:262:4: (lv_nodes_9_0= ruleNode )
            	    {
            	    // InternalActivity.g:262:4: (lv_nodes_9_0= ruleNode )
            	    // InternalActivity.g:263:5: lv_nodes_9_0= ruleNode
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivityAccess().getNodesNodeParserRuleCall_6_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_9);
            	    lv_nodes_9_0=ruleNode();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivityRule());
            	      					}
            	      					add(
            	      						current,
            	      						"nodes",
            	      						lv_nodes_9_0,
            	      						"org.eclipse.lsat.activity.teditor.Activity.Node");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

            otherlv_10=(Token)match(input,15,FOLLOW_11); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_10, grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_7());
              		
            }
            otherlv_11=(Token)match(input,17,FOLLOW_7); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_11, grammarAccess.getActivityAccess().getActionFlowKeyword_8());
              		
            }
            otherlv_12=(Token)match(input,13,FOLLOW_12); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_12, grammarAccess.getActivityAccess().getLeftCurlyBracketKeyword_9());
              		
            }
            // InternalActivity.g:292:3: ( (lv_edges_13_0= ruleEdges ) )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( ((LA6_0>=RULE_INT && LA6_0<=RULE_ID)||LA6_0==36) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // InternalActivity.g:293:4: (lv_edges_13_0= ruleEdges )
            	    {
            	    // InternalActivity.g:293:4: (lv_edges_13_0= ruleEdges )
            	    // InternalActivity.g:294:5: lv_edges_13_0= ruleEdges
            	    {
            	    if ( state.backtracking==0 ) {

            	      					newCompositeNode(grammarAccess.getActivityAccess().getEdgesEdgesParserRuleCall_10_0());
            	      				
            	    }
            	    pushFollow(FOLLOW_12);
            	    lv_edges_13_0=ruleEdges();

            	    state._fsp--;
            	    if (state.failed) return current;
            	    if ( state.backtracking==0 ) {

            	      					if (current==null) {
            	      						current = createModelElementForParent(grammarAccess.getActivityRule());
            	      					}
            	      					add(
            	      						current,
            	      						"edges",
            	      						lv_edges_13_0,
            	      						"org.eclipse.lsat.activity.teditor.Activity.Edges");
            	      					afterParserOrEnumRuleCall();
            	      				
            	    }

            	    }


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            otherlv_14=(Token)match(input,15,FOLLOW_13); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_14, grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_11());
              		
            }
            otherlv_15=(Token)match(input,15,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_15, grammarAccess.getActivityAccess().getRightCurlyBracketKeyword_12());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleActivity"


    // $ANTLR start "entryRuleResourceQualifiedName"
    // InternalActivity.g:323:1: entryRuleResourceQualifiedName returns [String current=null] : iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF ;
    public final String entryRuleResourceQualifiedName() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleResourceQualifiedName = null;


        try {
            // InternalActivity.g:323:61: (iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF )
            // InternalActivity.g:324:2: iv_ruleResourceQualifiedName= ruleResourceQualifiedName EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getResourceQualifiedNameRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleResourceQualifiedName=ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleResourceQualifiedName.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleResourceQualifiedName"


    // $ANTLR start "ruleResourceQualifiedName"
    // InternalActivity.g:330:1: ruleResourceQualifiedName returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) ;
    public final AntlrDatatypeRuleToken ruleResourceQualifiedName() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_IID_0 = null;

        AntlrDatatypeRuleToken this_IID_2 = null;



        	enterRule();

        try {
            // InternalActivity.g:336:2: ( (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? ) )
            // InternalActivity.g:337:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            {
            // InternalActivity.g:337:2: (this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )? )
            // InternalActivity.g:338:3: this_IID_0= ruleIID (kw= '.' this_IID_2= ruleIID )?
            {
            if ( state.backtracking==0 ) {

              			newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0());
              		
            }
            pushFollow(FOLLOW_14);
            this_IID_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			current.merge(this_IID_0);
              		
            }
            if ( state.backtracking==0 ) {

              			afterParserOrEnumRuleCall();
              		
            }
            // InternalActivity.g:348:3: (kw= '.' this_IID_2= ruleIID )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==18) ) {
                int LA7_1 = input.LA(2);

                if ( (LA7_1==RULE_INT) ) {
                    int LA7_3 = input.LA(3);

                    if ( (LA7_3==EOF||(LA7_3>=RULE_INT && LA7_3<=RULE_ID)||LA7_3==15||LA7_3==32) ) {
                        alt7=1;
                    }
                    else if ( (LA7_3==18) ) {
                        int LA7_6 = input.LA(4);

                        if ( (LA7_6==RULE_INT) ) {
                            int LA7_7 = input.LA(5);

                            if ( ((LA7_7>=18 && LA7_7<=19)||(LA7_7>=27 && LA7_7<=30)) ) {
                                alt7=1;
                            }
                        }
                        else if ( (LA7_6==RULE_ID) ) {
                            int LA7_8 = input.LA(5);

                            if ( ((LA7_8>=18 && LA7_8<=19)||(LA7_8>=27 && LA7_8<=30)) ) {
                                alt7=1;
                            }
                        }
                    }
                }
                else if ( (LA7_1==RULE_ID) ) {
                    int LA7_4 = input.LA(3);

                    if ( (LA7_4==EOF||(LA7_4>=RULE_INT && LA7_4<=RULE_ID)||LA7_4==15||LA7_4==32) ) {
                        alt7=1;
                    }
                    else if ( (LA7_4==18) ) {
                        int LA7_6 = input.LA(4);

                        if ( (LA7_6==RULE_INT) ) {
                            int LA7_7 = input.LA(5);

                            if ( ((LA7_7>=18 && LA7_7<=19)||(LA7_7>=27 && LA7_7<=30)) ) {
                                alt7=1;
                            }
                        }
                        else if ( (LA7_6==RULE_ID) ) {
                            int LA7_8 = input.LA(5);

                            if ( ((LA7_8>=18 && LA7_8<=19)||(LA7_8>=27 && LA7_8<=30)) ) {
                                alt7=1;
                            }
                        }
                    }
                }
            }
            switch (alt7) {
                case 1 :
                    // InternalActivity.g:349:4: kw= '.' this_IID_2= ruleIID
                    {
                    kw=(Token)match(input,18,FOLLOW_6); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(kw);
                      				newLeafNode(kw, grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0());
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				newCompositeNode(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1());
                      			
                    }
                    pushFollow(FOLLOW_2);
                    this_IID_2=ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current.merge(this_IID_2);
                      			
                    }
                    if ( state.backtracking==0 ) {

                      				afterParserOrEnumRuleCall();
                      			
                    }

                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleResourceQualifiedName"


    // $ANTLR start "entryRuleLocationPrerequisite"
    // InternalActivity.g:369:1: entryRuleLocationPrerequisite returns [EObject current=null] : iv_ruleLocationPrerequisite= ruleLocationPrerequisite EOF ;
    public final EObject entryRuleLocationPrerequisite() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleLocationPrerequisite = null;


        try {
            // InternalActivity.g:369:61: (iv_ruleLocationPrerequisite= ruleLocationPrerequisite EOF )
            // InternalActivity.g:370:2: iv_ruleLocationPrerequisite= ruleLocationPrerequisite EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getLocationPrerequisiteRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleLocationPrerequisite=ruleLocationPrerequisite();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleLocationPrerequisite; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleLocationPrerequisite"


    // $ANTLR start "ruleLocationPrerequisite"
    // InternalActivity.g:376:1: ruleLocationPrerequisite returns [EObject current=null] : ( ( ( ruleResourceQualifiedName ) ) otherlv_1= '.' ( ( ruleIID ) ) otherlv_3= 'at' ( ( ruleIID ) ) ) ;
    public final EObject ruleLocationPrerequisite() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;


        	enterRule();

        try {
            // InternalActivity.g:382:2: ( ( ( ( ruleResourceQualifiedName ) ) otherlv_1= '.' ( ( ruleIID ) ) otherlv_3= 'at' ( ( ruleIID ) ) ) )
            // InternalActivity.g:383:2: ( ( ( ruleResourceQualifiedName ) ) otherlv_1= '.' ( ( ruleIID ) ) otherlv_3= 'at' ( ( ruleIID ) ) )
            {
            // InternalActivity.g:383:2: ( ( ( ruleResourceQualifiedName ) ) otherlv_1= '.' ( ( ruleIID ) ) otherlv_3= 'at' ( ( ruleIID ) ) )
            // InternalActivity.g:384:3: ( ( ruleResourceQualifiedName ) ) otherlv_1= '.' ( ( ruleIID ) ) otherlv_3= 'at' ( ( ruleIID ) )
            {
            // InternalActivity.g:384:3: ( ( ruleResourceQualifiedName ) )
            // InternalActivity.g:385:4: ( ruleResourceQualifiedName )
            {
            // InternalActivity.g:385:4: ( ruleResourceQualifiedName )
            // InternalActivity.g:386:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getLocationPrerequisiteRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getLocationPrerequisiteAccess().getResourceIResourceCrossReference_0_0());
              				
            }
            pushFollow(FOLLOW_15);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_1=(Token)match(input,18,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_1, grammarAccess.getLocationPrerequisiteAccess().getFullStopKeyword_1());
              		
            }
            // InternalActivity.g:404:3: ( ( ruleIID ) )
            // InternalActivity.g:405:4: ( ruleIID )
            {
            // InternalActivity.g:405:4: ( ruleIID )
            // InternalActivity.g:406:5: ruleIID
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getLocationPrerequisiteRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getLocationPrerequisiteAccess().getPeripheralPeripheralCrossReference_2_0());
              				
            }
            pushFollow(FOLLOW_16);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,19,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getLocationPrerequisiteAccess().getAtKeyword_3());
              		
            }
            // InternalActivity.g:424:3: ( ( ruleIID ) )
            // InternalActivity.g:425:4: ( ruleIID )
            {
            // InternalActivity.g:425:4: ( ruleIID )
            // InternalActivity.g:426:5: ruleIID
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getLocationPrerequisiteRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getLocationPrerequisiteAccess().getPositionSymbolicPositionCrossReference_4_0());
              				
            }
            pushFollow(FOLLOW_2);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleLocationPrerequisite"


    // $ANTLR start "entryRuleNode"
    // InternalActivity.g:444:1: entryRuleNode returns [EObject current=null] : iv_ruleNode= ruleNode EOF ;
    public final EObject entryRuleNode() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleNode = null;


        try {
            // InternalActivity.g:444:45: (iv_ruleNode= ruleNode EOF )
            // InternalActivity.g:445:2: iv_ruleNode= ruleNode EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getNodeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleNode=ruleNode();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleNode; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleNode"


    // $ANTLR start "ruleNode"
    // InternalActivity.g:451:1: ruleNode returns [EObject current=null] : (this_Claim_0= ruleClaim | this_Release_1= ruleRelease | this_SimpleAction_2= ruleSimpleAction | this_Move_3= ruleMove | this_RequireEvent_4= ruleRequireEvent | this_RaiseEvent_5= ruleRaiseEvent ) ;
    public final EObject ruleNode() throws RecognitionException {
        EObject current = null;

        EObject this_Claim_0 = null;

        EObject this_Release_1 = null;

        EObject this_SimpleAction_2 = null;

        EObject this_Move_3 = null;

        EObject this_RequireEvent_4 = null;

        EObject this_RaiseEvent_5 = null;



        	enterRule();

        try {
            // InternalActivity.g:457:2: ( (this_Claim_0= ruleClaim | this_Release_1= ruleRelease | this_SimpleAction_2= ruleSimpleAction | this_Move_3= ruleMove | this_RequireEvent_4= ruleRequireEvent | this_RaiseEvent_5= ruleRaiseEvent ) )
            // InternalActivity.g:458:2: (this_Claim_0= ruleClaim | this_Release_1= ruleRelease | this_SimpleAction_2= ruleSimpleAction | this_Move_3= ruleMove | this_RequireEvent_4= ruleRequireEvent | this_RaiseEvent_5= ruleRaiseEvent )
            {
            // InternalActivity.g:458:2: (this_Claim_0= ruleClaim | this_Release_1= ruleRelease | this_SimpleAction_2= ruleSimpleAction | this_Move_3= ruleMove | this_RequireEvent_4= ruleRequireEvent | this_RaiseEvent_5= ruleRaiseEvent )
            int alt8=6;
            alt8 = dfa8.predict(input);
            switch (alt8) {
                case 1 :
                    // InternalActivity.g:459:3: this_Claim_0= ruleClaim
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getClaimParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_Claim_0=ruleClaim();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_Claim_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalActivity.g:468:3: this_Release_1= ruleRelease
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getReleaseParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_Release_1=ruleRelease();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_Release_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 3 :
                    // InternalActivity.g:477:3: this_SimpleAction_2= ruleSimpleAction
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getSimpleActionParserRuleCall_2());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_SimpleAction_2=ruleSimpleAction();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_SimpleAction_2;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 4 :
                    // InternalActivity.g:486:3: this_Move_3= ruleMove
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getMoveParserRuleCall_3());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_Move_3=ruleMove();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_Move_3;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 5 :
                    // InternalActivity.g:495:3: this_RequireEvent_4= ruleRequireEvent
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getRequireEventParserRuleCall_4());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_RequireEvent_4=ruleRequireEvent();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_RequireEvent_4;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 6 :
                    // InternalActivity.g:504:3: this_RaiseEvent_5= ruleRaiseEvent
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getNodeAccess().getRaiseEventParserRuleCall_5());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_RaiseEvent_5=ruleRaiseEvent();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_RaiseEvent_5;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleNode"


    // $ANTLR start "entryRuleClaim"
    // InternalActivity.g:516:1: entryRuleClaim returns [EObject current=null] : iv_ruleClaim= ruleClaim EOF ;
    public final EObject entryRuleClaim() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleClaim = null;


        try {
            // InternalActivity.g:516:46: (iv_ruleClaim= ruleClaim EOF )
            // InternalActivity.g:517:2: iv_ruleClaim= ruleClaim EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getClaimRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleClaim=ruleClaim();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleClaim; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleClaim"


    // $ANTLR start "ruleClaim"
    // InternalActivity.g:523:1: ruleClaim returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( (lv_passive_6_0= 'passive' ) )? otherlv_7= 'claim' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )? ) ;
    public final EObject ruleClaim() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token lv_passive_6_0=null;
        Token otherlv_7=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_entry_3_0 = null;

        EObject lv_outerEntry_4_0 = null;

        EObject lv_entry_5_0 = null;

        EObject lv_exit_9_0 = null;

        EObject lv_exit_10_0 = null;

        EObject lv_outerExit_11_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:529:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( (lv_passive_6_0= 'passive' ) )? otherlv_7= 'claim' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )? ) )
            // InternalActivity.g:530:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( (lv_passive_6_0= 'passive' ) )? otherlv_7= 'claim' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )? )
            {
            // InternalActivity.g:530:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( (lv_passive_6_0= 'passive' ) )? otherlv_7= 'claim' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )? )
            // InternalActivity.g:531:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( (lv_passive_6_0= 'passive' ) )? otherlv_7= 'claim' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )?
            {
            // InternalActivity.g:531:3: ()
            // InternalActivity.g:532:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getClaimAccess().getClaimAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:538:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:539:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:539:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:540:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getClaimAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getClaimRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_18); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getClaimAccess().getColonKeyword_2());
              		
            }
            // InternalActivity.g:561:3: ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )?
            int alt9=3;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA9_3 = input.LA(3);

                        if ( (LA9_3==RULE_STRING) ) {
                            int LA9_4 = input.LA(4);

                            if ( (LA9_4==34) ) {
                                int LA9_6 = input.LA(5);

                                if ( (LA9_6==32) ) {
                                    alt9=2;
                                }
                                else if ( ((LA9_6>=21 && LA9_6<=22)) ) {
                                    alt9=1;
                                }
                            }
                        }
                        else if ( (LA9_3==RULE_ID) ) {
                            int LA9_5 = input.LA(4);

                            if ( (LA9_5==34) ) {
                                int LA9_6 = input.LA(5);

                                if ( (LA9_6==32) ) {
                                    alt9=2;
                                }
                                else if ( ((LA9_6>=21 && LA9_6<=22)) ) {
                                    alt9=1;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA9_4 = input.LA(3);

                        if ( (LA9_4==34) ) {
                            int LA9_6 = input.LA(4);

                            if ( (LA9_6==32) ) {
                                alt9=2;
                            }
                            else if ( ((LA9_6>=21 && LA9_6<=22)) ) {
                                alt9=1;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA9_5 = input.LA(3);

                        if ( (LA9_5==34) ) {
                            int LA9_6 = input.LA(4);

                            if ( (LA9_6==32) ) {
                                alt9=2;
                            }
                            else if ( ((LA9_6>=21 && LA9_6<=22)) ) {
                                alt9=1;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt9) {
                case 1 :
                    // InternalActivity.g:562:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:562:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    // InternalActivity.g:563:5: (lv_entry_3_0= ruleTracePoint )
                    {
                    // InternalActivity.g:563:5: (lv_entry_3_0= ruleTracePoint )
                    // InternalActivity.g:564:6: lv_entry_3_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_19);
                    lv_entry_3_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getClaimRule());
                      						}
                      						set(
                      							current,
                      							"entry",
                      							lv_entry_3_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:582:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:582:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    // InternalActivity.g:583:5: ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:583:5: ( (lv_outerEntry_4_0= ruleTracePoint ) )
                    // InternalActivity.g:584:6: (lv_outerEntry_4_0= ruleTracePoint )
                    {
                    // InternalActivity.g:584:6: (lv_outerEntry_4_0= ruleTracePoint )
                    // InternalActivity.g:585:7: lv_outerEntry_4_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getClaimAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_outerEntry_4_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getClaimRule());
                      							}
                      							set(
                      								current,
                      								"outerEntry",
                      								lv_outerEntry_4_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:602:5: ( (lv_entry_5_0= ruleTracePoint ) )
                    // InternalActivity.g:603:6: (lv_entry_5_0= ruleTracePoint )
                    {
                    // InternalActivity.g:603:6: (lv_entry_5_0= ruleTracePoint )
                    // InternalActivity.g:604:7: lv_entry_5_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getClaimAccess().getEntryTracePointParserRuleCall_3_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_19);
                    lv_entry_5_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getClaimRule());
                      							}
                      							set(
                      								current,
                      								"entry",
                      								lv_entry_5_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalActivity.g:623:3: ( (lv_passive_6_0= 'passive' ) )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==21) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // InternalActivity.g:624:4: (lv_passive_6_0= 'passive' )
                    {
                    // InternalActivity.g:624:4: (lv_passive_6_0= 'passive' )
                    // InternalActivity.g:625:5: lv_passive_6_0= 'passive'
                    {
                    lv_passive_6_0=(Token)match(input,21,FOLLOW_21); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_passive_6_0, grammarAccess.getClaimAccess().getPassivePassiveKeyword_4_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getClaimRule());
                      					}
                      					setWithLastConsumed(current, "passive", lv_passive_6_0 != null, "passive");
                      				
                    }

                    }


                    }
                    break;

            }

            otherlv_7=(Token)match(input,22,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_7, grammarAccess.getClaimAccess().getClaimKeyword_5());
              		
            }
            // InternalActivity.g:641:3: ( ( ruleResourceQualifiedName ) )
            // InternalActivity.g:642:4: ( ruleResourceQualifiedName )
            {
            // InternalActivity.g:642:4: ( ruleResourceQualifiedName )
            // InternalActivity.g:643:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getClaimRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getClaimAccess().getResourceIResourceCrossReference_6_0());
              				
            }
            pushFollow(FOLLOW_22);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalActivity.g:657:3: ( ( (lv_exit_9_0= ruleTracePoint ) ) | ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) ) )?
            int alt11=3;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA11_3 = input.LA(3);

                        if ( (LA11_3==RULE_STRING) ) {
                            int LA11_4 = input.LA(4);

                            if ( (LA11_4==34) ) {
                                int LA11_6 = input.LA(5);

                                if ( (LA11_6==EOF||(LA11_6>=RULE_INT && LA11_6<=RULE_ID)||LA11_6==15) ) {
                                    alt11=1;
                                }
                                else if ( (LA11_6==32) ) {
                                    alt11=2;
                                }
                            }
                        }
                        else if ( (LA11_3==RULE_ID) ) {
                            int LA11_5 = input.LA(4);

                            if ( (LA11_5==34) ) {
                                int LA11_6 = input.LA(5);

                                if ( (LA11_6==EOF||(LA11_6>=RULE_INT && LA11_6<=RULE_ID)||LA11_6==15) ) {
                                    alt11=1;
                                }
                                else if ( (LA11_6==32) ) {
                                    alt11=2;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA11_4 = input.LA(3);

                        if ( (LA11_4==34) ) {
                            int LA11_6 = input.LA(4);

                            if ( (LA11_6==EOF||(LA11_6>=RULE_INT && LA11_6<=RULE_ID)||LA11_6==15) ) {
                                alt11=1;
                            }
                            else if ( (LA11_6==32) ) {
                                alt11=2;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA11_5 = input.LA(3);

                        if ( (LA11_5==34) ) {
                            int LA11_6 = input.LA(4);

                            if ( (LA11_6==EOF||(LA11_6>=RULE_INT && LA11_6<=RULE_ID)||LA11_6==15) ) {
                                alt11=1;
                            }
                            else if ( (LA11_6==32) ) {
                                alt11=2;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt11) {
                case 1 :
                    // InternalActivity.g:658:4: ( (lv_exit_9_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:658:4: ( (lv_exit_9_0= ruleTracePoint ) )
                    // InternalActivity.g:659:5: (lv_exit_9_0= ruleTracePoint )
                    {
                    // InternalActivity.g:659:5: (lv_exit_9_0= ruleTracePoint )
                    // InternalActivity.g:660:6: lv_exit_9_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_exit_9_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getClaimRule());
                      						}
                      						set(
                      							current,
                      							"exit",
                      							lv_exit_9_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:678:4: ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:678:4: ( ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) ) )
                    // InternalActivity.g:679:5: ( (lv_exit_10_0= ruleTracePoint ) ) ( (lv_outerExit_11_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:679:5: ( (lv_exit_10_0= ruleTracePoint ) )
                    // InternalActivity.g:680:6: (lv_exit_10_0= ruleTracePoint )
                    {
                    // InternalActivity.g:680:6: (lv_exit_10_0= ruleTracePoint )
                    // InternalActivity.g:681:7: lv_exit_10_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getClaimAccess().getExitTracePointParserRuleCall_7_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_exit_10_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getClaimRule());
                      							}
                      							set(
                      								current,
                      								"exit",
                      								lv_exit_10_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:698:5: ( (lv_outerExit_11_0= ruleTracePoint ) )
                    // InternalActivity.g:699:6: (lv_outerExit_11_0= ruleTracePoint )
                    {
                    // InternalActivity.g:699:6: (lv_outerExit_11_0= ruleTracePoint )
                    // InternalActivity.g:700:7: lv_outerExit_11_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getClaimAccess().getOuterExitTracePointParserRuleCall_7_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_outerExit_11_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getClaimRule());
                      							}
                      							set(
                      								current,
                      								"outerExit",
                      								lv_outerExit_11_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleClaim"


    // $ANTLR start "entryRuleRelease"
    // InternalActivity.g:723:1: entryRuleRelease returns [EObject current=null] : iv_ruleRelease= ruleRelease EOF ;
    public final EObject entryRuleRelease() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRelease = null;


        try {
            // InternalActivity.g:723:48: (iv_ruleRelease= ruleRelease EOF )
            // InternalActivity.g:724:2: iv_ruleRelease= ruleRelease EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getReleaseRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRelease=ruleRelease();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRelease; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRelease"


    // $ANTLR start "ruleRelease"
    // InternalActivity.g:730:1: ruleRelease returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'release' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )? ) ;
    public final EObject ruleRelease() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_6=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_entry_3_0 = null;

        EObject lv_outerEntry_4_0 = null;

        EObject lv_entry_5_0 = null;

        EObject lv_exit_8_0 = null;

        EObject lv_exit_9_0 = null;

        EObject lv_outerExit_10_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:736:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'release' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )? ) )
            // InternalActivity.g:737:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'release' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )? )
            {
            // InternalActivity.g:737:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'release' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )? )
            // InternalActivity.g:738:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'release' ( ( ruleResourceQualifiedName ) ) ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )?
            {
            // InternalActivity.g:738:3: ()
            // InternalActivity.g:739:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getReleaseAccess().getReleaseAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:745:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:746:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:746:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:747:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getReleaseAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getReleaseRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_23); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getReleaseAccess().getColonKeyword_2());
              		
            }
            // InternalActivity.g:768:3: ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )?
            int alt12=3;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA12_3 = input.LA(3);

                        if ( (LA12_3==RULE_STRING) ) {
                            int LA12_4 = input.LA(4);

                            if ( (LA12_4==34) ) {
                                int LA12_6 = input.LA(5);

                                if ( (LA12_6==23) ) {
                                    alt12=1;
                                }
                                else if ( (LA12_6==32) ) {
                                    alt12=2;
                                }
                            }
                        }
                        else if ( (LA12_3==RULE_ID) ) {
                            int LA12_5 = input.LA(4);

                            if ( (LA12_5==34) ) {
                                int LA12_6 = input.LA(5);

                                if ( (LA12_6==23) ) {
                                    alt12=1;
                                }
                                else if ( (LA12_6==32) ) {
                                    alt12=2;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA12_4 = input.LA(3);

                        if ( (LA12_4==34) ) {
                            int LA12_6 = input.LA(4);

                            if ( (LA12_6==23) ) {
                                alt12=1;
                            }
                            else if ( (LA12_6==32) ) {
                                alt12=2;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA12_5 = input.LA(3);

                        if ( (LA12_5==34) ) {
                            int LA12_6 = input.LA(4);

                            if ( (LA12_6==23) ) {
                                alt12=1;
                            }
                            else if ( (LA12_6==32) ) {
                                alt12=2;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt12) {
                case 1 :
                    // InternalActivity.g:769:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:769:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    // InternalActivity.g:770:5: (lv_entry_3_0= ruleTracePoint )
                    {
                    // InternalActivity.g:770:5: (lv_entry_3_0= ruleTracePoint )
                    // InternalActivity.g:771:6: lv_entry_3_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_24);
                    lv_entry_3_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getReleaseRule());
                      						}
                      						set(
                      							current,
                      							"entry",
                      							lv_entry_3_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:789:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:789:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    // InternalActivity.g:790:5: ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:790:5: ( (lv_outerEntry_4_0= ruleTracePoint ) )
                    // InternalActivity.g:791:6: (lv_outerEntry_4_0= ruleTracePoint )
                    {
                    // InternalActivity.g:791:6: (lv_outerEntry_4_0= ruleTracePoint )
                    // InternalActivity.g:792:7: lv_outerEntry_4_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getReleaseAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_outerEntry_4_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getReleaseRule());
                      							}
                      							set(
                      								current,
                      								"outerEntry",
                      								lv_outerEntry_4_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:809:5: ( (lv_entry_5_0= ruleTracePoint ) )
                    // InternalActivity.g:810:6: (lv_entry_5_0= ruleTracePoint )
                    {
                    // InternalActivity.g:810:6: (lv_entry_5_0= ruleTracePoint )
                    // InternalActivity.g:811:7: lv_entry_5_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getReleaseAccess().getEntryTracePointParserRuleCall_3_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_24);
                    lv_entry_5_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getReleaseRule());
                      							}
                      							set(
                      								current,
                      								"entry",
                      								lv_entry_5_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            otherlv_6=(Token)match(input,23,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getReleaseAccess().getReleaseKeyword_4());
              		
            }
            // InternalActivity.g:834:3: ( ( ruleResourceQualifiedName ) )
            // InternalActivity.g:835:4: ( ruleResourceQualifiedName )
            {
            // InternalActivity.g:835:4: ( ruleResourceQualifiedName )
            // InternalActivity.g:836:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getReleaseRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getReleaseAccess().getResourceIResourceCrossReference_5_0());
              				
            }
            pushFollow(FOLLOW_22);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalActivity.g:850:3: ( ( (lv_exit_8_0= ruleTracePoint ) ) | ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) ) )?
            int alt13=3;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA13_3 = input.LA(3);

                        if ( (LA13_3==RULE_STRING) ) {
                            int LA13_4 = input.LA(4);

                            if ( (LA13_4==34) ) {
                                int LA13_6 = input.LA(5);

                                if ( (LA13_6==EOF||(LA13_6>=RULE_INT && LA13_6<=RULE_ID)||LA13_6==15) ) {
                                    alt13=1;
                                }
                                else if ( (LA13_6==32) ) {
                                    alt13=2;
                                }
                            }
                        }
                        else if ( (LA13_3==RULE_ID) ) {
                            int LA13_5 = input.LA(4);

                            if ( (LA13_5==34) ) {
                                int LA13_6 = input.LA(5);

                                if ( (LA13_6==EOF||(LA13_6>=RULE_INT && LA13_6<=RULE_ID)||LA13_6==15) ) {
                                    alt13=1;
                                }
                                else if ( (LA13_6==32) ) {
                                    alt13=2;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA13_4 = input.LA(3);

                        if ( (LA13_4==34) ) {
                            int LA13_6 = input.LA(4);

                            if ( (LA13_6==EOF||(LA13_6>=RULE_INT && LA13_6<=RULE_ID)||LA13_6==15) ) {
                                alt13=1;
                            }
                            else if ( (LA13_6==32) ) {
                                alt13=2;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA13_5 = input.LA(3);

                        if ( (LA13_5==34) ) {
                            int LA13_6 = input.LA(4);

                            if ( (LA13_6==EOF||(LA13_6>=RULE_INT && LA13_6<=RULE_ID)||LA13_6==15) ) {
                                alt13=1;
                            }
                            else if ( (LA13_6==32) ) {
                                alt13=2;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt13) {
                case 1 :
                    // InternalActivity.g:851:4: ( (lv_exit_8_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:851:4: ( (lv_exit_8_0= ruleTracePoint ) )
                    // InternalActivity.g:852:5: (lv_exit_8_0= ruleTracePoint )
                    {
                    // InternalActivity.g:852:5: (lv_exit_8_0= ruleTracePoint )
                    // InternalActivity.g:853:6: lv_exit_8_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_exit_8_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getReleaseRule());
                      						}
                      						set(
                      							current,
                      							"exit",
                      							lv_exit_8_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:871:4: ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:871:4: ( ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) ) )
                    // InternalActivity.g:872:5: ( (lv_exit_9_0= ruleTracePoint ) ) ( (lv_outerExit_10_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:872:5: ( (lv_exit_9_0= ruleTracePoint ) )
                    // InternalActivity.g:873:6: (lv_exit_9_0= ruleTracePoint )
                    {
                    // InternalActivity.g:873:6: (lv_exit_9_0= ruleTracePoint )
                    // InternalActivity.g:874:7: lv_exit_9_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getReleaseAccess().getExitTracePointParserRuleCall_6_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_exit_9_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getReleaseRule());
                      							}
                      							set(
                      								current,
                      								"exit",
                      								lv_exit_9_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:891:5: ( (lv_outerExit_10_0= ruleTracePoint ) )
                    // InternalActivity.g:892:6: (lv_outerExit_10_0= ruleTracePoint )
                    {
                    // InternalActivity.g:892:6: (lv_outerExit_10_0= ruleTracePoint )
                    // InternalActivity.g:893:7: lv_outerExit_10_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getReleaseAccess().getOuterExitTracePointParserRuleCall_6_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_outerExit_10_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getReleaseRule());
                      							}
                      							set(
                      								current,
                      								"outerExit",
                      								lv_outerExit_10_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRelease"


    // $ANTLR start "entryRuleRaiseEvent"
    // InternalActivity.g:916:1: entryRuleRaiseEvent returns [EObject current=null] : iv_ruleRaiseEvent= ruleRaiseEvent EOF ;
    public final EObject entryRuleRaiseEvent() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRaiseEvent = null;


        try {
            // InternalActivity.g:916:51: (iv_ruleRaiseEvent= ruleRaiseEvent EOF )
            // InternalActivity.g:917:2: iv_ruleRaiseEvent= ruleRaiseEvent EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRaiseEventRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRaiseEvent=ruleRaiseEvent();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRaiseEvent; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRaiseEvent"


    // $ANTLR start "ruleRaiseEvent"
    // InternalActivity.g:923:1: ruleRaiseEvent returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'raise' ( (lv_eventName_4_0= ruleIID ) ) ) ;
    public final EObject ruleRaiseEvent() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_3=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        AntlrDatatypeRuleToken lv_eventName_4_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:929:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'raise' ( (lv_eventName_4_0= ruleIID ) ) ) )
            // InternalActivity.g:930:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'raise' ( (lv_eventName_4_0= ruleIID ) ) )
            {
            // InternalActivity.g:930:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'raise' ( (lv_eventName_4_0= ruleIID ) ) )
            // InternalActivity.g:931:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'raise' ( (lv_eventName_4_0= ruleIID ) )
            {
            // InternalActivity.g:931:3: ()
            // InternalActivity.g:932:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRaiseEventAccess().getRaiseEventAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:938:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:939:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:939:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:940:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRaiseEventAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRaiseEventRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_25); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getRaiseEventAccess().getColonKeyword_2());
              		
            }
            otherlv_3=(Token)match(input,24,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getRaiseEventAccess().getRaiseKeyword_3());
              		
            }
            // InternalActivity.g:965:3: ( (lv_eventName_4_0= ruleIID ) )
            // InternalActivity.g:966:4: (lv_eventName_4_0= ruleIID )
            {
            // InternalActivity.g:966:4: (lv_eventName_4_0= ruleIID )
            // InternalActivity.g:967:5: lv_eventName_4_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRaiseEventAccess().getEventNameIIDParserRuleCall_4_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_eventName_4_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRaiseEventRule());
              					}
              					set(
              						current,
              						"eventName",
              						lv_eventName_4_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRaiseEvent"


    // $ANTLR start "entryRuleRequireEvent"
    // InternalActivity.g:988:1: entryRuleRequireEvent returns [EObject current=null] : iv_ruleRequireEvent= ruleRequireEvent EOF ;
    public final EObject entryRuleRequireEvent() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRequireEvent = null;


        try {
            // InternalActivity.g:988:53: (iv_ruleRequireEvent= ruleRequireEvent EOF )
            // InternalActivity.g:989:2: iv_ruleRequireEvent= ruleRequireEvent EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getRequireEventRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleRequireEvent=ruleRequireEvent();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleRequireEvent; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRequireEvent"


    // $ANTLR start "ruleRequireEvent"
    // InternalActivity.g:995:1: ruleRequireEvent returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'require' ( (lv_eventName_4_0= ruleIID ) ) ) ;
    public final EObject ruleRequireEvent() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_3=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        AntlrDatatypeRuleToken lv_eventName_4_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1001:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'require' ( (lv_eventName_4_0= ruleIID ) ) ) )
            // InternalActivity.g:1002:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'require' ( (lv_eventName_4_0= ruleIID ) ) )
            {
            // InternalActivity.g:1002:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'require' ( (lv_eventName_4_0= ruleIID ) ) )
            // InternalActivity.g:1003:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' otherlv_3= 'require' ( (lv_eventName_4_0= ruleIID ) )
            {
            // InternalActivity.g:1003:3: ()
            // InternalActivity.g:1004:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getRequireEventAccess().getRequireEventAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1010:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:1011:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:1011:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:1012:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRequireEventAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRequireEventRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_26); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getRequireEventAccess().getColonKeyword_2());
              		
            }
            otherlv_3=(Token)match(input,25,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getRequireEventAccess().getRequireKeyword_3());
              		
            }
            // InternalActivity.g:1037:3: ( (lv_eventName_4_0= ruleIID ) )
            // InternalActivity.g:1038:4: (lv_eventName_4_0= ruleIID )
            {
            // InternalActivity.g:1038:4: (lv_eventName_4_0= ruleIID )
            // InternalActivity.g:1039:5: lv_eventName_4_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getRequireEventAccess().getEventNameIIDParserRuleCall_4_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_eventName_4_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getRequireEventRule());
              					}
              					set(
              						current,
              						"eventName",
              						lv_eventName_4_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRequireEvent"


    // $ANTLR start "entryRuleMove"
    // InternalActivity.g:1060:1: entryRuleMove returns [EObject current=null] : iv_ruleMove= ruleMove EOF ;
    public final EObject entryRuleMove() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleMove = null;


        try {
            // InternalActivity.g:1060:45: (iv_ruleMove= ruleMove EOF )
            // InternalActivity.g:1061:2: iv_ruleMove= ruleMove EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getMoveRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleMove=ruleMove();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleMove; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleMove"


    // $ANTLR start "ruleMove"
    // InternalActivity.g:1067:1: ruleMove returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'move' ( ( ruleResourceQualifiedName ) ) otherlv_8= '.' ( ( ruleIID ) ) ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) ) (otherlv_16= 'with speed profile' ( ( ruleIID ) ) ) ( (lv_schedulingType_18_0= ruleScheduling ) )? ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )? ) ;
    public final EObject ruleMove() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token lv_passing_10_0=null;
        Token otherlv_11=null;
        Token lv_continuing_13_0=null;
        Token otherlv_14=null;
        Token otherlv_16=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_entry_3_0 = null;

        EObject lv_outerEntry_4_0 = null;

        EObject lv_entry_5_0 = null;

        Enumerator lv_schedulingType_18_0 = null;

        EObject lv_exit_19_0 = null;

        EObject lv_exit_20_0 = null;

        EObject lv_outerExit_21_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1073:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'move' ( ( ruleResourceQualifiedName ) ) otherlv_8= '.' ( ( ruleIID ) ) ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) ) (otherlv_16= 'with speed profile' ( ( ruleIID ) ) ) ( (lv_schedulingType_18_0= ruleScheduling ) )? ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )? ) )
            // InternalActivity.g:1074:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'move' ( ( ruleResourceQualifiedName ) ) otherlv_8= '.' ( ( ruleIID ) ) ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) ) (otherlv_16= 'with speed profile' ( ( ruleIID ) ) ) ( (lv_schedulingType_18_0= ruleScheduling ) )? ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )? )
            {
            // InternalActivity.g:1074:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'move' ( ( ruleResourceQualifiedName ) ) otherlv_8= '.' ( ( ruleIID ) ) ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) ) (otherlv_16= 'with speed profile' ( ( ruleIID ) ) ) ( (lv_schedulingType_18_0= ruleScheduling ) )? ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )? )
            // InternalActivity.g:1075:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? otherlv_6= 'move' ( ( ruleResourceQualifiedName ) ) otherlv_8= '.' ( ( ruleIID ) ) ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) ) (otherlv_16= 'with speed profile' ( ( ruleIID ) ) ) ( (lv_schedulingType_18_0= ruleScheduling ) )? ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )?
            {
            // InternalActivity.g:1075:3: ()
            // InternalActivity.g:1076:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getMoveAccess().getMoveAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1082:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:1083:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:1083:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:1084:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getMoveAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getMoveRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_27); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getMoveAccess().getColonKeyword_2());
              		
            }
            // InternalActivity.g:1105:3: ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )?
            int alt14=3;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA14_3 = input.LA(3);

                        if ( (LA14_3==RULE_STRING) ) {
                            int LA14_4 = input.LA(4);

                            if ( (LA14_4==34) ) {
                                int LA14_6 = input.LA(5);

                                if ( (LA14_6==32) ) {
                                    alt14=2;
                                }
                                else if ( (LA14_6==26) ) {
                                    alt14=1;
                                }
                            }
                        }
                        else if ( (LA14_3==RULE_ID) ) {
                            int LA14_5 = input.LA(4);

                            if ( (LA14_5==34) ) {
                                int LA14_6 = input.LA(5);

                                if ( (LA14_6==32) ) {
                                    alt14=2;
                                }
                                else if ( (LA14_6==26) ) {
                                    alt14=1;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA14_4 = input.LA(3);

                        if ( (LA14_4==34) ) {
                            int LA14_6 = input.LA(4);

                            if ( (LA14_6==32) ) {
                                alt14=2;
                            }
                            else if ( (LA14_6==26) ) {
                                alt14=1;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA14_5 = input.LA(3);

                        if ( (LA14_5==34) ) {
                            int LA14_6 = input.LA(4);

                            if ( (LA14_6==32) ) {
                                alt14=2;
                            }
                            else if ( (LA14_6==26) ) {
                                alt14=1;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt14) {
                case 1 :
                    // InternalActivity.g:1106:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1106:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    // InternalActivity.g:1107:5: (lv_entry_3_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1107:5: (lv_entry_3_0= ruleTracePoint )
                    // InternalActivity.g:1108:6: lv_entry_3_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_28);
                    lv_entry_3_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getMoveRule());
                      						}
                      						set(
                      							current,
                      							"entry",
                      							lv_entry_3_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1126:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:1126:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    // InternalActivity.g:1127:5: ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1127:5: ( (lv_outerEntry_4_0= ruleTracePoint ) )
                    // InternalActivity.g:1128:6: (lv_outerEntry_4_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1128:6: (lv_outerEntry_4_0= ruleTracePoint )
                    // InternalActivity.g:1129:7: lv_outerEntry_4_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_outerEntry_4_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMoveRule());
                      							}
                      							set(
                      								current,
                      								"outerEntry",
                      								lv_outerEntry_4_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:1146:5: ( (lv_entry_5_0= ruleTracePoint ) )
                    // InternalActivity.g:1147:6: (lv_entry_5_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1147:6: (lv_entry_5_0= ruleTracePoint )
                    // InternalActivity.g:1148:7: lv_entry_5_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getEntryTracePointParserRuleCall_3_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_28);
                    lv_entry_5_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMoveRule());
                      							}
                      							set(
                      								current,
                      								"entry",
                      								lv_entry_5_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            otherlv_6=(Token)match(input,26,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_6, grammarAccess.getMoveAccess().getMoveKeyword_4());
              		
            }
            // InternalActivity.g:1171:3: ( ( ruleResourceQualifiedName ) )
            // InternalActivity.g:1172:4: ( ruleResourceQualifiedName )
            {
            // InternalActivity.g:1172:4: ( ruleResourceQualifiedName )
            // InternalActivity.g:1173:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getMoveRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getMoveAccess().getResourceIResourceCrossReference_5_0());
              				
            }
            pushFollow(FOLLOW_15);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_8=(Token)match(input,18,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_8, grammarAccess.getMoveAccess().getFullStopKeyword_6());
              		
            }
            // InternalActivity.g:1191:3: ( ( ruleIID ) )
            // InternalActivity.g:1192:4: ( ruleIID )
            {
            // InternalActivity.g:1192:4: ( ruleIID )
            // InternalActivity.g:1193:5: ruleIID
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getMoveRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getMoveAccess().getPeripheralPeripheralCrossReference_7_0());
              				
            }
            pushFollow(FOLLOW_29);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalActivity.g:1207:3: ( ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) ) | ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) ) )
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( ((LA17_0>=27 && LA17_0<=28)) ) {
                alt17=1;
            }
            else if ( ((LA17_0>=29 && LA17_0<=30)) ) {
                alt17=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 17, 0, input);

                throw nvae;
            }
            switch (alt17) {
                case 1 :
                    // InternalActivity.g:1208:4: ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) )
                    {
                    // InternalActivity.g:1208:4: ( ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) ) )
                    // InternalActivity.g:1209:5: ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' ) ( ( ruleIID ) )
                    {
                    // InternalActivity.g:1209:5: ( ( (lv_passing_10_0= 'passing' ) ) | otherlv_11= 'to' )
                    int alt15=2;
                    int LA15_0 = input.LA(1);

                    if ( (LA15_0==27) ) {
                        alt15=1;
                    }
                    else if ( (LA15_0==28) ) {
                        alt15=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 15, 0, input);

                        throw nvae;
                    }
                    switch (alt15) {
                        case 1 :
                            // InternalActivity.g:1210:6: ( (lv_passing_10_0= 'passing' ) )
                            {
                            // InternalActivity.g:1210:6: ( (lv_passing_10_0= 'passing' ) )
                            // InternalActivity.g:1211:7: (lv_passing_10_0= 'passing' )
                            {
                            // InternalActivity.g:1211:7: (lv_passing_10_0= 'passing' )
                            // InternalActivity.g:1212:8: lv_passing_10_0= 'passing'
                            {
                            lv_passing_10_0=(Token)match(input,27,FOLLOW_6); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(lv_passing_10_0, grammarAccess.getMoveAccess().getPassingPassingKeyword_8_0_0_0_0());
                              							
                            }
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElement(grammarAccess.getMoveRule());
                              								}
                              								setWithLastConsumed(current, "passing", lv_passing_10_0 != null, "passing");
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            // InternalActivity.g:1225:6: otherlv_11= 'to'
                            {
                            otherlv_11=(Token)match(input,28,FOLLOW_6); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_11, grammarAccess.getMoveAccess().getToKeyword_8_0_0_1());
                              					
                            }

                            }
                            break;

                    }

                    // InternalActivity.g:1230:5: ( ( ruleIID ) )
                    // InternalActivity.g:1231:6: ( ruleIID )
                    {
                    // InternalActivity.g:1231:6: ( ruleIID )
                    // InternalActivity.g:1232:7: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getMoveRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getTargetPositionSymbolicPositionCrossReference_8_0_1_0());
                      						
                    }
                    pushFollow(FOLLOW_30);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1248:4: ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) )
                    {
                    // InternalActivity.g:1248:4: ( ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) ) )
                    // InternalActivity.g:1249:5: ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' ) ( ( ruleIID ) )
                    {
                    // InternalActivity.g:1249:5: ( ( (lv_continuing_13_0= 'continuing' ) ) | otherlv_14= 'for' )
                    int alt16=2;
                    int LA16_0 = input.LA(1);

                    if ( (LA16_0==29) ) {
                        alt16=1;
                    }
                    else if ( (LA16_0==30) ) {
                        alt16=2;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 16, 0, input);

                        throw nvae;
                    }
                    switch (alt16) {
                        case 1 :
                            // InternalActivity.g:1250:6: ( (lv_continuing_13_0= 'continuing' ) )
                            {
                            // InternalActivity.g:1250:6: ( (lv_continuing_13_0= 'continuing' ) )
                            // InternalActivity.g:1251:7: (lv_continuing_13_0= 'continuing' )
                            {
                            // InternalActivity.g:1251:7: (lv_continuing_13_0= 'continuing' )
                            // InternalActivity.g:1252:8: lv_continuing_13_0= 'continuing'
                            {
                            lv_continuing_13_0=(Token)match(input,29,FOLLOW_6); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              								newLeafNode(lv_continuing_13_0, grammarAccess.getMoveAccess().getContinuingContinuingKeyword_8_1_0_0_0());
                              							
                            }
                            if ( state.backtracking==0 ) {

                              								if (current==null) {
                              									current = createModelElement(grammarAccess.getMoveRule());
                              								}
                              								setWithLastConsumed(current, "continuing", lv_continuing_13_0 != null, "continuing");
                              							
                            }

                            }


                            }


                            }
                            break;
                        case 2 :
                            // InternalActivity.g:1265:6: otherlv_14= 'for'
                            {
                            otherlv_14=(Token)match(input,30,FOLLOW_6); if (state.failed) return current;
                            if ( state.backtracking==0 ) {

                              						newLeafNode(otherlv_14, grammarAccess.getMoveAccess().getForKeyword_8_1_0_1());
                              					
                            }

                            }
                            break;

                    }

                    // InternalActivity.g:1270:5: ( ( ruleIID ) )
                    // InternalActivity.g:1271:6: ( ruleIID )
                    {
                    // InternalActivity.g:1271:6: ( ruleIID )
                    // InternalActivity.g:1272:7: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getMoveRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getDistanceDistanceCrossReference_8_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_30);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalActivity.g:1288:3: (otherlv_16= 'with speed profile' ( ( ruleIID ) ) )
            // InternalActivity.g:1289:4: otherlv_16= 'with speed profile' ( ( ruleIID ) )
            {
            otherlv_16=(Token)match(input,31,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				newLeafNode(otherlv_16, grammarAccess.getMoveAccess().getWithSpeedProfileKeyword_9_0());
              			
            }
            // InternalActivity.g:1293:4: ( ( ruleIID ) )
            // InternalActivity.g:1294:5: ( ruleIID )
            {
            // InternalActivity.g:1294:5: ( ruleIID )
            // InternalActivity.g:1295:6: ruleIID
            {
            if ( state.backtracking==0 ) {

              						if (current==null) {
              							current = createModelElement(grammarAccess.getMoveRule());
              						}
              					
            }
            if ( state.backtracking==0 ) {

              						newCompositeNode(grammarAccess.getMoveAccess().getProfileProfileCrossReference_9_1_0());
              					
            }
            pushFollow(FOLLOW_31);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              						afterParserOrEnumRuleCall();
              					
            }

            }


            }


            }

            // InternalActivity.g:1310:3: ( (lv_schedulingType_18_0= ruleScheduling ) )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( ((LA18_0>=37 && LA18_0<=38)) ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // InternalActivity.g:1311:4: (lv_schedulingType_18_0= ruleScheduling )
                    {
                    // InternalActivity.g:1311:4: (lv_schedulingType_18_0= ruleScheduling )
                    // InternalActivity.g:1312:5: lv_schedulingType_18_0= ruleScheduling
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getMoveAccess().getSchedulingTypeSchedulingEnumRuleCall_10_0());
                      				
                    }
                    pushFollow(FOLLOW_22);
                    lv_schedulingType_18_0=ruleScheduling();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getMoveRule());
                      					}
                      					set(
                      						current,
                      						"schedulingType",
                      						lv_schedulingType_18_0,
                      						"org.eclipse.lsat.activity.teditor.Activity.Scheduling");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }

            // InternalActivity.g:1329:3: ( ( (lv_exit_19_0= ruleTracePoint ) ) | ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) ) )?
            int alt19=3;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA19_3 = input.LA(3);

                        if ( (LA19_3==RULE_STRING) ) {
                            int LA19_4 = input.LA(4);

                            if ( (LA19_4==34) ) {
                                int LA19_6 = input.LA(5);

                                if ( (LA19_6==32) ) {
                                    alt19=2;
                                }
                                else if ( (LA19_6==EOF||(LA19_6>=RULE_INT && LA19_6<=RULE_ID)||LA19_6==15) ) {
                                    alt19=1;
                                }
                            }
                        }
                        else if ( (LA19_3==RULE_ID) ) {
                            int LA19_5 = input.LA(4);

                            if ( (LA19_5==34) ) {
                                int LA19_6 = input.LA(5);

                                if ( (LA19_6==32) ) {
                                    alt19=2;
                                }
                                else if ( (LA19_6==EOF||(LA19_6>=RULE_INT && LA19_6<=RULE_ID)||LA19_6==15) ) {
                                    alt19=1;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA19_4 = input.LA(3);

                        if ( (LA19_4==34) ) {
                            int LA19_6 = input.LA(4);

                            if ( (LA19_6==32) ) {
                                alt19=2;
                            }
                            else if ( (LA19_6==EOF||(LA19_6>=RULE_INT && LA19_6<=RULE_ID)||LA19_6==15) ) {
                                alt19=1;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA19_5 = input.LA(3);

                        if ( (LA19_5==34) ) {
                            int LA19_6 = input.LA(4);

                            if ( (LA19_6==32) ) {
                                alt19=2;
                            }
                            else if ( (LA19_6==EOF||(LA19_6>=RULE_INT && LA19_6<=RULE_ID)||LA19_6==15) ) {
                                alt19=1;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt19) {
                case 1 :
                    // InternalActivity.g:1330:4: ( (lv_exit_19_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1330:4: ( (lv_exit_19_0= ruleTracePoint ) )
                    // InternalActivity.g:1331:5: (lv_exit_19_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1331:5: (lv_exit_19_0= ruleTracePoint )
                    // InternalActivity.g:1332:6: lv_exit_19_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_exit_19_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getMoveRule());
                      						}
                      						set(
                      							current,
                      							"exit",
                      							lv_exit_19_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1350:4: ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:1350:4: ( ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) ) )
                    // InternalActivity.g:1351:5: ( (lv_exit_20_0= ruleTracePoint ) ) ( (lv_outerExit_21_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1351:5: ( (lv_exit_20_0= ruleTracePoint ) )
                    // InternalActivity.g:1352:6: (lv_exit_20_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1352:6: (lv_exit_20_0= ruleTracePoint )
                    // InternalActivity.g:1353:7: lv_exit_20_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getExitTracePointParserRuleCall_11_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_exit_20_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMoveRule());
                      							}
                      							set(
                      								current,
                      								"exit",
                      								lv_exit_20_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:1370:5: ( (lv_outerExit_21_0= ruleTracePoint ) )
                    // InternalActivity.g:1371:6: (lv_outerExit_21_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1371:6: (lv_outerExit_21_0= ruleTracePoint )
                    // InternalActivity.g:1372:7: lv_outerExit_21_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getMoveAccess().getOuterExitTracePointParserRuleCall_11_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_outerExit_21_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getMoveRule());
                      							}
                      							set(
                      								current,
                      								"outerExit",
                      								lv_outerExit_21_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleMove"


    // $ANTLR start "entryRuleSimpleAction"
    // InternalActivity.g:1395:1: entryRuleSimpleAction returns [EObject current=null] : iv_ruleSimpleAction= ruleSimpleAction EOF ;
    public final EObject entryRuleSimpleAction() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSimpleAction = null;


        try {
            // InternalActivity.g:1395:53: (iv_ruleSimpleAction= ruleSimpleAction EOF )
            // InternalActivity.g:1396:2: iv_ruleSimpleAction= ruleSimpleAction EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getSimpleActionRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleSimpleAction=ruleSimpleAction();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleSimpleAction; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSimpleAction"


    // $ANTLR start "ruleSimpleAction"
    // InternalActivity.g:1402:1: ruleSimpleAction returns [EObject current=null] : ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( ( ruleResourceQualifiedName ) ) ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) ) ( (lv_schedulingType_11_0= ruleScheduling ) )? ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )? ) ;
    public final EObject ruleSimpleAction() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_entry_3_0 = null;

        EObject lv_outerEntry_4_0 = null;

        EObject lv_entry_5_0 = null;

        Enumerator lv_schedulingType_11_0 = null;

        EObject lv_exit_12_0 = null;

        EObject lv_exit_13_0 = null;

        EObject lv_outerExit_14_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1408:2: ( ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( ( ruleResourceQualifiedName ) ) ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) ) ( (lv_schedulingType_11_0= ruleScheduling ) )? ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )? ) )
            // InternalActivity.g:1409:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( ( ruleResourceQualifiedName ) ) ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) ) ( (lv_schedulingType_11_0= ruleScheduling ) )? ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )? )
            {
            // InternalActivity.g:1409:2: ( () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( ( ruleResourceQualifiedName ) ) ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) ) ( (lv_schedulingType_11_0= ruleScheduling ) )? ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )? )
            // InternalActivity.g:1410:3: () ( (lv_name_1_0= ruleIID ) ) otherlv_2= ':' ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )? ( ( ruleResourceQualifiedName ) ) ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) ) ( (lv_schedulingType_11_0= ruleScheduling ) )? ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )?
            {
            // InternalActivity.g:1410:3: ()
            // InternalActivity.g:1411:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getSimpleActionAccess().getSimpleActionAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1417:3: ( (lv_name_1_0= ruleIID ) )
            // InternalActivity.g:1418:4: (lv_name_1_0= ruleIID )
            {
            // InternalActivity.g:1418:4: (lv_name_1_0= ruleIID )
            // InternalActivity.g:1419:5: lv_name_1_0= ruleIID
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getSimpleActionAccess().getNameIIDParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_17);
            lv_name_1_0=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getSimpleActionRule());
              					}
              					set(
              						current,
              						"name",
              						lv_name_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.IID");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,20,FOLLOW_32); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getSimpleActionAccess().getColonKeyword_2());
              		
            }
            // InternalActivity.g:1440:3: ( ( (lv_entry_3_0= ruleTracePoint ) ) | ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) ) )?
            int alt20=3;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA20_3 = input.LA(3);

                        if ( (LA20_3==RULE_STRING) ) {
                            int LA20_4 = input.LA(4);

                            if ( (LA20_4==34) ) {
                                int LA20_6 = input.LA(5);

                                if ( (LA20_6==32) ) {
                                    alt20=2;
                                }
                                else if ( ((LA20_6>=RULE_INT && LA20_6<=RULE_ID)) ) {
                                    alt20=1;
                                }
                            }
                        }
                        else if ( (LA20_3==RULE_ID) ) {
                            int LA20_5 = input.LA(4);

                            if ( (LA20_5==34) ) {
                                int LA20_6 = input.LA(5);

                                if ( (LA20_6==32) ) {
                                    alt20=2;
                                }
                                else if ( ((LA20_6>=RULE_INT && LA20_6<=RULE_ID)) ) {
                                    alt20=1;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA20_4 = input.LA(3);

                        if ( (LA20_4==34) ) {
                            int LA20_6 = input.LA(4);

                            if ( (LA20_6==32) ) {
                                alt20=2;
                            }
                            else if ( ((LA20_6>=RULE_INT && LA20_6<=RULE_ID)) ) {
                                alt20=1;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA20_5 = input.LA(3);

                        if ( (LA20_5==34) ) {
                            int LA20_6 = input.LA(4);

                            if ( (LA20_6==32) ) {
                                alt20=2;
                            }
                            else if ( ((LA20_6>=RULE_INT && LA20_6<=RULE_ID)) ) {
                                alt20=1;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt20) {
                case 1 :
                    // InternalActivity.g:1441:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1441:4: ( (lv_entry_3_0= ruleTracePoint ) )
                    // InternalActivity.g:1442:5: (lv_entry_3_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1442:5: (lv_entry_3_0= ruleTracePoint )
                    // InternalActivity.g:1443:6: lv_entry_3_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_0_0());
                      					
                    }
                    pushFollow(FOLLOW_6);
                    lv_entry_3_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      						}
                      						set(
                      							current,
                      							"entry",
                      							lv_entry_3_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1461:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:1461:4: ( ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) ) )
                    // InternalActivity.g:1462:5: ( (lv_outerEntry_4_0= ruleTracePoint ) ) ( (lv_entry_5_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1462:5: ( (lv_outerEntry_4_0= ruleTracePoint ) )
                    // InternalActivity.g:1463:6: (lv_outerEntry_4_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1463:6: (lv_outerEntry_4_0= ruleTracePoint )
                    // InternalActivity.g:1464:7: lv_outerEntry_4_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getSimpleActionAccess().getOuterEntryTracePointParserRuleCall_3_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_outerEntry_4_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      							}
                      							set(
                      								current,
                      								"outerEntry",
                      								lv_outerEntry_4_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:1481:5: ( (lv_entry_5_0= ruleTracePoint ) )
                    // InternalActivity.g:1482:6: (lv_entry_5_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1482:6: (lv_entry_5_0= ruleTracePoint )
                    // InternalActivity.g:1483:7: lv_entry_5_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getSimpleActionAccess().getEntryTracePointParserRuleCall_3_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_6);
                    lv_entry_5_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      							}
                      							set(
                      								current,
                      								"entry",
                      								lv_entry_5_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }

            // InternalActivity.g:1502:3: ( ( ruleResourceQualifiedName ) )
            // InternalActivity.g:1503:4: ( ruleResourceQualifiedName )
            {
            // InternalActivity.g:1503:4: ( ruleResourceQualifiedName )
            // InternalActivity.g:1504:5: ruleResourceQualifiedName
            {
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElement(grammarAccess.getSimpleActionRule());
              					}
              				
            }
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getSimpleActionAccess().getResourceIResourceCrossReference_4_0());
              				
            }
            pushFollow(FOLLOW_15);
            ruleResourceQualifiedName();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            // InternalActivity.g:1518:3: ( ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) ) )
            // InternalActivity.g:1519:4: ( ( '.' )=>otherlv_7= '.' ) ( ( ruleIID ) ) otherlv_9= '.' ( ( ruleIID ) )
            {
            // InternalActivity.g:1519:4: ( ( '.' )=>otherlv_7= '.' )
            // InternalActivity.g:1520:5: ( '.' )=>otherlv_7= '.'
            {
            otherlv_7=(Token)match(input,18,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					newLeafNode(otherlv_7, grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_0());
              				
            }

            }

            // InternalActivity.g:1526:4: ( ( ruleIID ) )
            // InternalActivity.g:1527:5: ( ruleIID )
            {
            // InternalActivity.g:1527:5: ( ruleIID )
            // InternalActivity.g:1528:6: ruleIID
            {
            if ( state.backtracking==0 ) {

              						if (current==null) {
              							current = createModelElement(grammarAccess.getSimpleActionRule());
              						}
              					
            }
            if ( state.backtracking==0 ) {

              						newCompositeNode(grammarAccess.getSimpleActionAccess().getPeripheralPeripheralCrossReference_5_1_0());
              					
            }
            pushFollow(FOLLOW_15);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              						afterParserOrEnumRuleCall();
              					
            }

            }


            }

            otherlv_9=(Token)match(input,18,FOLLOW_6); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              				newLeafNode(otherlv_9, grammarAccess.getSimpleActionAccess().getFullStopKeyword_5_2());
              			
            }
            // InternalActivity.g:1546:4: ( ( ruleIID ) )
            // InternalActivity.g:1547:5: ( ruleIID )
            {
            // InternalActivity.g:1547:5: ( ruleIID )
            // InternalActivity.g:1548:6: ruleIID
            {
            if ( state.backtracking==0 ) {

              						if (current==null) {
              							current = createModelElement(grammarAccess.getSimpleActionRule());
              						}
              					
            }
            if ( state.backtracking==0 ) {

              						newCompositeNode(grammarAccess.getSimpleActionAccess().getTypeActionTypeCrossReference_5_3_0());
              					
            }
            pushFollow(FOLLOW_31);
            ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              						afterParserOrEnumRuleCall();
              					
            }

            }


            }


            }

            // InternalActivity.g:1563:3: ( (lv_schedulingType_11_0= ruleScheduling ) )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( ((LA21_0>=37 && LA21_0<=38)) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // InternalActivity.g:1564:4: (lv_schedulingType_11_0= ruleScheduling )
                    {
                    // InternalActivity.g:1564:4: (lv_schedulingType_11_0= ruleScheduling )
                    // InternalActivity.g:1565:5: lv_schedulingType_11_0= ruleScheduling
                    {
                    if ( state.backtracking==0 ) {

                      					newCompositeNode(grammarAccess.getSimpleActionAccess().getSchedulingTypeSchedulingEnumRuleCall_6_0());
                      				
                    }
                    pushFollow(FOLLOW_22);
                    lv_schedulingType_11_0=ruleScheduling();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      					}
                      					set(
                      						current,
                      						"schedulingType",
                      						lv_schedulingType_11_0,
                      						"org.eclipse.lsat.activity.teditor.Activity.Scheduling");
                      					afterParserOrEnumRuleCall();
                      				
                    }

                    }


                    }
                    break;

            }

            // InternalActivity.g:1582:3: ( ( (lv_exit_12_0= ruleTracePoint ) ) | ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) ) )?
            int alt22=3;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==32) ) {
                switch ( input.LA(2) ) {
                    case 33:
                        {
                        int LA22_3 = input.LA(3);

                        if ( (LA22_3==RULE_STRING) ) {
                            int LA22_4 = input.LA(4);

                            if ( (LA22_4==34) ) {
                                int LA22_6 = input.LA(5);

                                if ( (LA22_6==EOF||(LA22_6>=RULE_INT && LA22_6<=RULE_ID)||LA22_6==15) ) {
                                    alt22=1;
                                }
                                else if ( (LA22_6==32) ) {
                                    alt22=2;
                                }
                            }
                        }
                        else if ( (LA22_3==RULE_ID) ) {
                            int LA22_5 = input.LA(4);

                            if ( (LA22_5==34) ) {
                                int LA22_6 = input.LA(5);

                                if ( (LA22_6==EOF||(LA22_6>=RULE_INT && LA22_6<=RULE_ID)||LA22_6==15) ) {
                                    alt22=1;
                                }
                                else if ( (LA22_6==32) ) {
                                    alt22=2;
                                }
                            }
                        }
                        }
                        break;
                    case RULE_STRING:
                        {
                        int LA22_4 = input.LA(3);

                        if ( (LA22_4==34) ) {
                            int LA22_6 = input.LA(4);

                            if ( (LA22_6==EOF||(LA22_6>=RULE_INT && LA22_6<=RULE_ID)||LA22_6==15) ) {
                                alt22=1;
                            }
                            else if ( (LA22_6==32) ) {
                                alt22=2;
                            }
                        }
                        }
                        break;
                    case RULE_ID:
                        {
                        int LA22_5 = input.LA(3);

                        if ( (LA22_5==34) ) {
                            int LA22_6 = input.LA(4);

                            if ( (LA22_6==EOF||(LA22_6>=RULE_INT && LA22_6<=RULE_ID)||LA22_6==15) ) {
                                alt22=1;
                            }
                            else if ( (LA22_6==32) ) {
                                alt22=2;
                            }
                        }
                        }
                        break;
                }

            }
            switch (alt22) {
                case 1 :
                    // InternalActivity.g:1583:4: ( (lv_exit_12_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1583:4: ( (lv_exit_12_0= ruleTracePoint ) )
                    // InternalActivity.g:1584:5: (lv_exit_12_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1584:5: (lv_exit_12_0= ruleTracePoint )
                    // InternalActivity.g:1585:6: lv_exit_12_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    lv_exit_12_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      						}
                      						set(
                      							current,
                      							"exit",
                      							lv_exit_12_0,
                      							"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1603:4: ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) )
                    {
                    // InternalActivity.g:1603:4: ( ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) ) )
                    // InternalActivity.g:1604:5: ( (lv_exit_13_0= ruleTracePoint ) ) ( (lv_outerExit_14_0= ruleTracePoint ) )
                    {
                    // InternalActivity.g:1604:5: ( (lv_exit_13_0= ruleTracePoint ) )
                    // InternalActivity.g:1605:6: (lv_exit_13_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1605:6: (lv_exit_13_0= ruleTracePoint )
                    // InternalActivity.g:1606:7: lv_exit_13_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getSimpleActionAccess().getExitTracePointParserRuleCall_7_1_0_0());
                      						
                    }
                    pushFollow(FOLLOW_20);
                    lv_exit_13_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      							}
                      							set(
                      								current,
                      								"exit",
                      								lv_exit_13_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }

                    // InternalActivity.g:1623:5: ( (lv_outerExit_14_0= ruleTracePoint ) )
                    // InternalActivity.g:1624:6: (lv_outerExit_14_0= ruleTracePoint )
                    {
                    // InternalActivity.g:1624:6: (lv_outerExit_14_0= ruleTracePoint )
                    // InternalActivity.g:1625:7: lv_outerExit_14_0= ruleTracePoint
                    {
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getSimpleActionAccess().getOuterExitTracePointParserRuleCall_7_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    lv_outerExit_14_0=ruleTracePoint();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElementForParent(grammarAccess.getSimpleActionRule());
                      							}
                      							set(
                      								current,
                      								"outerExit",
                      								lv_outerExit_14_0,
                      								"org.eclipse.lsat.activity.teditor.Activity.TracePoint");
                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSimpleAction"


    // $ANTLR start "entryRuleTracePoint"
    // InternalActivity.g:1648:1: entryRuleTracePoint returns [EObject current=null] : iv_ruleTracePoint= ruleTracePoint EOF ;
    public final EObject entryRuleTracePoint() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTracePoint = null;


        try {
            // InternalActivity.g:1648:51: (iv_ruleTracePoint= ruleTracePoint EOF )
            // InternalActivity.g:1649:2: iv_ruleTracePoint= ruleTracePoint EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getTracePointRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleTracePoint=ruleTracePoint();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleTracePoint; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTracePoint"


    // $ANTLR start "ruleTracePoint"
    // InternalActivity.g:1655:1: ruleTracePoint returns [EObject current=null] : (otherlv_0= '[' ( (lv_regex_1_0= '~' ) )? ( (lv_value_2_0= ruleEString ) ) otherlv_3= ']' ) ;
    public final EObject ruleTracePoint() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_regex_1_0=null;
        Token otherlv_3=null;
        AntlrDatatypeRuleToken lv_value_2_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1661:2: ( (otherlv_0= '[' ( (lv_regex_1_0= '~' ) )? ( (lv_value_2_0= ruleEString ) ) otherlv_3= ']' ) )
            // InternalActivity.g:1662:2: (otherlv_0= '[' ( (lv_regex_1_0= '~' ) )? ( (lv_value_2_0= ruleEString ) ) otherlv_3= ']' )
            {
            // InternalActivity.g:1662:2: (otherlv_0= '[' ( (lv_regex_1_0= '~' ) )? ( (lv_value_2_0= ruleEString ) ) otherlv_3= ']' )
            // InternalActivity.g:1663:3: otherlv_0= '[' ( (lv_regex_1_0= '~' ) )? ( (lv_value_2_0= ruleEString ) ) otherlv_3= ']'
            {
            otherlv_0=(Token)match(input,32,FOLLOW_33); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_0, grammarAccess.getTracePointAccess().getLeftSquareBracketKeyword_0());
              		
            }
            // InternalActivity.g:1667:3: ( (lv_regex_1_0= '~' ) )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==33) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // InternalActivity.g:1668:4: (lv_regex_1_0= '~' )
                    {
                    // InternalActivity.g:1668:4: (lv_regex_1_0= '~' )
                    // InternalActivity.g:1669:5: lv_regex_1_0= '~'
                    {
                    lv_regex_1_0=(Token)match(input,33,FOLLOW_33); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(lv_regex_1_0, grammarAccess.getTracePointAccess().getRegexTildeKeyword_1_0());
                      				
                    }
                    if ( state.backtracking==0 ) {

                      					if (current==null) {
                      						current = createModelElement(grammarAccess.getTracePointRule());
                      					}
                      					setWithLastConsumed(current, "regex", lv_regex_1_0 != null, "~");
                      				
                    }

                    }


                    }
                    break;

            }

            // InternalActivity.g:1681:3: ( (lv_value_2_0= ruleEString ) )
            // InternalActivity.g:1682:4: (lv_value_2_0= ruleEString )
            {
            // InternalActivity.g:1682:4: (lv_value_2_0= ruleEString )
            // InternalActivity.g:1683:5: lv_value_2_0= ruleEString
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getTracePointAccess().getValueEStringParserRuleCall_2_0());
              				
            }
            pushFollow(FOLLOW_34);
            lv_value_2_0=ruleEString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getTracePointRule());
              					}
              					set(
              						current,
              						"value",
              						lv_value_2_0,
              						"org.eclipse.lsat.activity.teditor.Activity.EString");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_3=(Token)match(input,34,FOLLOW_2); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_3, grammarAccess.getTracePointAccess().getRightSquareBracketKeyword_3());
              		
            }

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTracePoint"


    // $ANTLR start "entryRuleEdges"
    // InternalActivity.g:1708:1: entryRuleEdges returns [EObject current=null] : iv_ruleEdges= ruleEdges EOF ;
    public final EObject entryRuleEdges() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdges = null;


        try {
            // InternalActivity.g:1708:46: (iv_ruleEdges= ruleEdges EOF )
            // InternalActivity.g:1709:2: iv_ruleEdges= ruleEdges EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgesRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdges=ruleEdges();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdges; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdges"


    // $ANTLR start "ruleEdges"
    // InternalActivity.g:1715:1: ruleEdges returns [EObject current=null] : this_Edge_0= ruleEdge ;
    public final EObject ruleEdges() throws RecognitionException {
        EObject current = null;

        EObject this_Edge_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1721:2: (this_Edge_0= ruleEdge )
            // InternalActivity.g:1722:2: this_Edge_0= ruleEdge
            {
            if ( state.backtracking==0 ) {

              		newCompositeNode(grammarAccess.getEdgesAccess().getEdgeParserRuleCall());
              	
            }
            pushFollow(FOLLOW_2);
            this_Edge_0=ruleEdge();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              		current = this_Edge_0;
              		afterParserOrEnumRuleCall();
              	
            }

            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdges"


    // $ANTLR start "entryRuleEdge"
    // InternalActivity.g:1733:1: entryRuleEdge returns [EObject current=null] : iv_ruleEdge= ruleEdge EOF ;
    public final EObject entryRuleEdge() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleEdge = null;


        try {
            // InternalActivity.g:1733:45: (iv_ruleEdge= ruleEdge EOF )
            // InternalActivity.g:1734:2: iv_ruleEdge= ruleEdge EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEdgeRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEdge=ruleEdge();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEdge; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEdge"


    // $ANTLR start "ruleEdge"
    // InternalActivity.g:1740:1: ruleEdge returns [EObject current=null] : ( () ( (lv_source_1_0= ruleSourceReference ) ) otherlv_2= '->' ( (lv_target_3_0= ruleDependencyTarget ) ) ) ;
    public final EObject ruleEdge() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        EObject lv_source_1_0 = null;

        EObject lv_target_3_0 = null;



        	enterRule();

        try {
            // InternalActivity.g:1746:2: ( ( () ( (lv_source_1_0= ruleSourceReference ) ) otherlv_2= '->' ( (lv_target_3_0= ruleDependencyTarget ) ) ) )
            // InternalActivity.g:1747:2: ( () ( (lv_source_1_0= ruleSourceReference ) ) otherlv_2= '->' ( (lv_target_3_0= ruleDependencyTarget ) ) )
            {
            // InternalActivity.g:1747:2: ( () ( (lv_source_1_0= ruleSourceReference ) ) otherlv_2= '->' ( (lv_target_3_0= ruleDependencyTarget ) ) )
            // InternalActivity.g:1748:3: () ( (lv_source_1_0= ruleSourceReference ) ) otherlv_2= '->' ( (lv_target_3_0= ruleDependencyTarget ) )
            {
            // InternalActivity.g:1748:3: ()
            // InternalActivity.g:1749:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getEdgeAccess().getEdgeAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1755:3: ( (lv_source_1_0= ruleSourceReference ) )
            // InternalActivity.g:1756:4: (lv_source_1_0= ruleSourceReference )
            {
            // InternalActivity.g:1756:4: (lv_source_1_0= ruleSourceReference )
            // InternalActivity.g:1757:5: lv_source_1_0= ruleSourceReference
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeAccess().getSourceSourceReferenceParserRuleCall_1_0());
              				
            }
            pushFollow(FOLLOW_35);
            lv_source_1_0=ruleSourceReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRule());
              					}
              					set(
              						current,
              						"source",
              						lv_source_1_0,
              						"org.eclipse.lsat.activity.teditor.Activity.SourceReference");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }

            otherlv_2=(Token)match(input,35,FOLLOW_36); if (state.failed) return current;
            if ( state.backtracking==0 ) {

              			newLeafNode(otherlv_2, grammarAccess.getEdgeAccess().getHyphenMinusGreaterThanSignKeyword_2());
              		
            }
            // InternalActivity.g:1778:3: ( (lv_target_3_0= ruleDependencyTarget ) )
            // InternalActivity.g:1779:4: (lv_target_3_0= ruleDependencyTarget )
            {
            // InternalActivity.g:1779:4: (lv_target_3_0= ruleDependencyTarget )
            // InternalActivity.g:1780:5: lv_target_3_0= ruleDependencyTarget
            {
            if ( state.backtracking==0 ) {

              					newCompositeNode(grammarAccess.getEdgeAccess().getTargetDependencyTargetParserRuleCall_3_0());
              				
            }
            pushFollow(FOLLOW_2);
            lv_target_3_0=ruleDependencyTarget();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {

              					if (current==null) {
              						current = createModelElementForParent(grammarAccess.getEdgeRule());
              					}
              					set(
              						current,
              						"target",
              						lv_target_3_0,
              						"org.eclipse.lsat.activity.teditor.Activity.DependencyTarget");
              					afterParserOrEnumRuleCall();
              				
            }

            }


            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEdge"


    // $ANTLR start "entryRuleSourceReference"
    // InternalActivity.g:1801:1: entryRuleSourceReference returns [EObject current=null] : iv_ruleSourceReference= ruleSourceReference EOF ;
    public final EObject entryRuleSourceReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSourceReference = null;


        try {
            // InternalActivity.g:1801:56: (iv_ruleSourceReference= ruleSourceReference EOF )
            // InternalActivity.g:1802:2: iv_ruleSourceReference= ruleSourceReference EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getSourceReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleSourceReference=ruleSourceReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleSourceReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSourceReference"


    // $ANTLR start "ruleSourceReference"
    // InternalActivity.g:1808:1: ruleSourceReference returns [EObject current=null] : ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) ) ;
    public final EObject ruleSourceReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;


        	enterRule();

        try {
            // InternalActivity.g:1814:2: ( ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) ) )
            // InternalActivity.g:1815:2: ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) )
            {
            // InternalActivity.g:1815:2: ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) )
            // InternalActivity.g:1816:3: () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) )
            {
            // InternalActivity.g:1816:3: ()
            // InternalActivity.g:1817:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getSourceReferenceAccess().getSourceReferenceAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1823:3: ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) )
            int alt24=2;
            int LA24_0 = input.LA(1);

            if ( ((LA24_0>=RULE_INT && LA24_0<=RULE_ID)) ) {
                alt24=1;
            }
            else if ( (LA24_0==36) ) {
                alt24=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 24, 0, input);

                throw nvae;
            }
            switch (alt24) {
                case 1 :
                    // InternalActivity.g:1824:4: ( ( ruleIID ) )
                    {
                    // InternalActivity.g:1824:4: ( ( ruleIID ) )
                    // InternalActivity.g:1825:5: ( ruleIID )
                    {
                    // InternalActivity.g:1825:5: ( ruleIID )
                    // InternalActivity.g:1826:6: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getSourceReferenceRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getSourceReferenceAccess().getNodeActionCrossReference_1_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1841:4: (otherlv_2= '|' ( ( ruleIID ) ) )
                    {
                    // InternalActivity.g:1841:4: (otherlv_2= '|' ( ( ruleIID ) ) )
                    // InternalActivity.g:1842:5: otherlv_2= '|' ( ( ruleIID ) )
                    {
                    otherlv_2=(Token)match(input,36,FOLLOW_6); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_2, grammarAccess.getSourceReferenceAccess().getVerticalLineKeyword_1_1_0());
                      				
                    }
                    // InternalActivity.g:1846:5: ( ( ruleIID ) )
                    // InternalActivity.g:1847:6: ( ruleIID )
                    {
                    // InternalActivity.g:1847:6: ( ruleIID )
                    // InternalActivity.g:1848:7: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getSourceReferenceRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getSourceReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSourceReference"


    // $ANTLR start "entryRuleDependencyTarget"
    // InternalActivity.g:1868:1: entryRuleDependencyTarget returns [EObject current=null] : iv_ruleDependencyTarget= ruleDependencyTarget EOF ;
    public final EObject entryRuleDependencyTarget() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDependencyTarget = null;


        try {
            // InternalActivity.g:1868:57: (iv_ruleDependencyTarget= ruleDependencyTarget EOF )
            // InternalActivity.g:1869:2: iv_ruleDependencyTarget= ruleDependencyTarget EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getDependencyTargetRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleDependencyTarget=ruleDependencyTarget();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleDependencyTarget; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDependencyTarget"


    // $ANTLR start "ruleDependencyTarget"
    // InternalActivity.g:1875:1: ruleDependencyTarget returns [EObject current=null] : (this_TargetReference_0= ruleTargetReference | this_Edge_1= ruleEdge ) ;
    public final EObject ruleDependencyTarget() throws RecognitionException {
        EObject current = null;

        EObject this_TargetReference_0 = null;

        EObject this_Edge_1 = null;



        	enterRule();

        try {
            // InternalActivity.g:1881:2: ( (this_TargetReference_0= ruleTargetReference | this_Edge_1= ruleEdge ) )
            // InternalActivity.g:1882:2: (this_TargetReference_0= ruleTargetReference | this_Edge_1= ruleEdge )
            {
            // InternalActivity.g:1882:2: (this_TargetReference_0= ruleTargetReference | this_Edge_1= ruleEdge )
            int alt25=2;
            switch ( input.LA(1) ) {
            case RULE_INT:
                {
                int LA25_1 = input.LA(2);

                if ( (LA25_1==35) ) {
                    alt25=2;
                }
                else if ( (LA25_1==EOF||(LA25_1>=RULE_INT && LA25_1<=RULE_ID)||LA25_1==15||LA25_1==36) ) {
                    alt25=1;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 1, input);

                    throw nvae;
                }
                }
                break;
            case RULE_ID:
                {
                int LA25_2 = input.LA(2);

                if ( (LA25_2==EOF||(LA25_2>=RULE_INT && LA25_2<=RULE_ID)||LA25_2==15||LA25_2==36) ) {
                    alt25=1;
                }
                else if ( (LA25_2==35) ) {
                    alt25=2;
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 2, input);

                    throw nvae;
                }
                }
                break;
            case 36:
                {
                int LA25_3 = input.LA(2);

                if ( (LA25_3==RULE_INT) ) {
                    int LA25_6 = input.LA(3);

                    if ( (LA25_6==35) ) {
                        alt25=2;
                    }
                    else if ( (LA25_6==EOF||(LA25_6>=RULE_INT && LA25_6<=RULE_ID)||LA25_6==15||LA25_6==36) ) {
                        alt25=1;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 25, 6, input);

                        throw nvae;
                    }
                }
                else if ( (LA25_3==RULE_ID) ) {
                    int LA25_7 = input.LA(3);

                    if ( (LA25_7==35) ) {
                        alt25=2;
                    }
                    else if ( (LA25_7==EOF||(LA25_7>=RULE_INT && LA25_7<=RULE_ID)||LA25_7==15||LA25_7==36) ) {
                        alt25=1;
                    }
                    else {
                        if (state.backtracking>0) {state.failed=true; return current;}
                        NoViableAltException nvae =
                            new NoViableAltException("", 25, 7, input);

                        throw nvae;
                    }
                }
                else {
                    if (state.backtracking>0) {state.failed=true; return current;}
                    NoViableAltException nvae =
                        new NoViableAltException("", 25, 3, input);

                    throw nvae;
                }
                }
                break;
            default:
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }

            switch (alt25) {
                case 1 :
                    // InternalActivity.g:1883:3: this_TargetReference_0= ruleTargetReference
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getDependencyTargetAccess().getTargetReferenceParserRuleCall_0());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_TargetReference_0=ruleTargetReference();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_TargetReference_0;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalActivity.g:1892:3: this_Edge_1= ruleEdge
                    {
                    if ( state.backtracking==0 ) {

                      			newCompositeNode(grammarAccess.getDependencyTargetAccess().getEdgeParserRuleCall_1());
                      		
                    }
                    pushFollow(FOLLOW_2);
                    this_Edge_1=ruleEdge();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current = this_Edge_1;
                      			afterParserOrEnumRuleCall();
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDependencyTarget"


    // $ANTLR start "entryRuleTargetReference"
    // InternalActivity.g:1904:1: entryRuleTargetReference returns [EObject current=null] : iv_ruleTargetReference= ruleTargetReference EOF ;
    public final EObject entryRuleTargetReference() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTargetReference = null;


        try {
            // InternalActivity.g:1904:56: (iv_ruleTargetReference= ruleTargetReference EOF )
            // InternalActivity.g:1905:2: iv_ruleTargetReference= ruleTargetReference EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getTargetReferenceRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleTargetReference=ruleTargetReference();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleTargetReference; 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTargetReference"


    // $ANTLR start "ruleTargetReference"
    // InternalActivity.g:1911:1: ruleTargetReference returns [EObject current=null] : ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) ) ;
    public final EObject ruleTargetReference() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;


        	enterRule();

        try {
            // InternalActivity.g:1917:2: ( ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) ) )
            // InternalActivity.g:1918:2: ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) )
            {
            // InternalActivity.g:1918:2: ( () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) ) )
            // InternalActivity.g:1919:3: () ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) )
            {
            // InternalActivity.g:1919:3: ()
            // InternalActivity.g:1920:4: 
            {
            if ( state.backtracking==0 ) {

              				current = forceCreateModelElement(
              					grammarAccess.getTargetReferenceAccess().getTargetReferenceAction_0(),
              					current);
              			
            }

            }

            // InternalActivity.g:1926:3: ( ( ( ruleIID ) ) | (otherlv_2= '|' ( ( ruleIID ) ) ) )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( ((LA26_0>=RULE_INT && LA26_0<=RULE_ID)) ) {
                alt26=1;
            }
            else if ( (LA26_0==36) ) {
                alt26=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // InternalActivity.g:1927:4: ( ( ruleIID ) )
                    {
                    // InternalActivity.g:1927:4: ( ( ruleIID ) )
                    // InternalActivity.g:1928:5: ( ruleIID )
                    {
                    // InternalActivity.g:1928:5: ( ruleIID )
                    // InternalActivity.g:1929:6: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      						if (current==null) {
                      							current = createModelElement(grammarAccess.getTargetReferenceRule());
                      						}
                      					
                    }
                    if ( state.backtracking==0 ) {

                      						newCompositeNode(grammarAccess.getTargetReferenceAccess().getNodeActionCrossReference_1_0_0());
                      					
                    }
                    pushFollow(FOLLOW_2);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      						afterParserOrEnumRuleCall();
                      					
                    }

                    }


                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:1944:4: (otherlv_2= '|' ( ( ruleIID ) ) )
                    {
                    // InternalActivity.g:1944:4: (otherlv_2= '|' ( ( ruleIID ) ) )
                    // InternalActivity.g:1945:5: otherlv_2= '|' ( ( ruleIID ) )
                    {
                    otherlv_2=(Token)match(input,36,FOLLOW_6); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      					newLeafNode(otherlv_2, grammarAccess.getTargetReferenceAccess().getVerticalLineKeyword_1_1_0());
                      				
                    }
                    // InternalActivity.g:1949:5: ( ( ruleIID ) )
                    // InternalActivity.g:1950:6: ( ruleIID )
                    {
                    // InternalActivity.g:1950:6: ( ruleIID )
                    // InternalActivity.g:1951:7: ruleIID
                    {
                    if ( state.backtracking==0 ) {

                      							if (current==null) {
                      								current = createModelElement(grammarAccess.getTargetReferenceRule());
                      							}
                      						
                    }
                    if ( state.backtracking==0 ) {

                      							newCompositeNode(grammarAccess.getTargetReferenceAccess().getNodeSyncBarCrossReference_1_1_1_0());
                      						
                    }
                    pushFollow(FOLLOW_2);
                    ruleIID();

                    state._fsp--;
                    if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      							afterParserOrEnumRuleCall();
                      						
                    }

                    }


                    }


                    }


                    }
                    break;

            }


            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTargetReference"


    // $ANTLR start "entryRuleIID"
    // InternalActivity.g:1971:1: entryRuleIID returns [String current=null] : iv_ruleIID= ruleIID EOF ;
    public final String entryRuleIID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleIID = null;


        try {
            // InternalActivity.g:1971:43: (iv_ruleIID= ruleIID EOF )
            // InternalActivity.g:1972:2: iv_ruleIID= ruleIID EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getIIDRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleIID=ruleIID();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleIID.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalActivity.g:1978:1: ruleIID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleIID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalActivity.g:1984:2: ( (this_INT_0= RULE_INT | this_ID_1= RULE_ID ) )
            // InternalActivity.g:1985:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            {
            // InternalActivity.g:1985:2: (this_INT_0= RULE_INT | this_ID_1= RULE_ID )
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==RULE_INT) ) {
                alt27=1;
            }
            else if ( (LA27_0==RULE_ID) ) {
                alt27=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 27, 0, input);

                throw nvae;
            }
            switch (alt27) {
                case 1 :
                    // InternalActivity.g:1986:3: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_INT_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_INT_0, grammarAccess.getIIDAccess().getINTTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalActivity.g:1994:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_1, grammarAccess.getIIDAccess().getIDTerminalRuleCall_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleIID"


    // $ANTLR start "entryRuleEString"
    // InternalActivity.g:2005:1: entryRuleEString returns [String current=null] : iv_ruleEString= ruleEString EOF ;
    public final String entryRuleEString() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEString = null;


        try {
            // InternalActivity.g:2005:47: (iv_ruleEString= ruleEString EOF )
            // InternalActivity.g:2006:2: iv_ruleEString= ruleEString EOF
            {
            if ( state.backtracking==0 ) {
               newCompositeNode(grammarAccess.getEStringRule()); 
            }
            pushFollow(FOLLOW_1);
            iv_ruleEString=ruleEString();

            state._fsp--;
            if (state.failed) return current;
            if ( state.backtracking==0 ) {
               current =iv_ruleEString.getText(); 
            }
            match(input,EOF,FOLLOW_2); if (state.failed) return current;

            }

        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEString"


    // $ANTLR start "ruleEString"
    // InternalActivity.g:2012:1: ruleEString returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleEString() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_STRING_0=null;
        Token this_ID_1=null;


        	enterRule();

        try {
            // InternalActivity.g:2018:2: ( (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) )
            // InternalActivity.g:2019:2: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            {
            // InternalActivity.g:2019:2: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==RULE_STRING) ) {
                alt28=1;
            }
            else if ( (LA28_0==RULE_ID) ) {
                alt28=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 28, 0, input);

                throw nvae;
            }
            switch (alt28) {
                case 1 :
                    // InternalActivity.g:2020:3: this_STRING_0= RULE_STRING
                    {
                    this_STRING_0=(Token)match(input,RULE_STRING,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_STRING_0);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_STRING_0, grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0());
                      		
                    }

                    }
                    break;
                case 2 :
                    // InternalActivity.g:2028:3: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      			current.merge(this_ID_1);
                      		
                    }
                    if ( state.backtracking==0 ) {

                      			newLeafNode(this_ID_1, grammarAccess.getEStringAccess().getIDTerminalRuleCall_1());
                      		
                    }

                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEString"


    // $ANTLR start "ruleScheduling"
    // InternalActivity.g:2039:1: ruleScheduling returns [Enumerator current=null] : ( (enumLiteral_0= 'ASAP' ) | (enumLiteral_1= 'ALAP' ) ) ;
    public final Enumerator ruleScheduling() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;


        	enterRule();

        try {
            // InternalActivity.g:2045:2: ( ( (enumLiteral_0= 'ASAP' ) | (enumLiteral_1= 'ALAP' ) ) )
            // InternalActivity.g:2046:2: ( (enumLiteral_0= 'ASAP' ) | (enumLiteral_1= 'ALAP' ) )
            {
            // InternalActivity.g:2046:2: ( (enumLiteral_0= 'ASAP' ) | (enumLiteral_1= 'ALAP' ) )
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==37) ) {
                alt29=1;
            }
            else if ( (LA29_0==38) ) {
                alt29=2;
            }
            else {
                if (state.backtracking>0) {state.failed=true; return current;}
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }
            switch (alt29) {
                case 1 :
                    // InternalActivity.g:2047:3: (enumLiteral_0= 'ASAP' )
                    {
                    // InternalActivity.g:2047:3: (enumLiteral_0= 'ASAP' )
                    // InternalActivity.g:2048:4: enumLiteral_0= 'ASAP'
                    {
                    enumLiteral_0=(Token)match(input,37,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getSchedulingAccess().getASAPEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_0, grammarAccess.getSchedulingAccess().getASAPEnumLiteralDeclaration_0());
                      			
                    }

                    }


                    }
                    break;
                case 2 :
                    // InternalActivity.g:2055:3: (enumLiteral_1= 'ALAP' )
                    {
                    // InternalActivity.g:2055:3: (enumLiteral_1= 'ALAP' )
                    // InternalActivity.g:2056:4: enumLiteral_1= 'ALAP'
                    {
                    enumLiteral_1=(Token)match(input,38,FOLLOW_2); if (state.failed) return current;
                    if ( state.backtracking==0 ) {

                      				current = grammarAccess.getSchedulingAccess().getALAPEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                      				newLeafNode(enumLiteral_1, grammarAccess.getSchedulingAccess().getALAPEnumLiteralDeclaration_1());
                      			
                    }

                    }


                    }
                    break;

            }


            }

            if ( state.backtracking==0 ) {

              	leaveRule();

            }
        }

            catch (RecognitionException re) {
                recover(input,re);
                appendSkippedTokens();
            }
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleScheduling"

    // Delegated rules


    protected DFA8 dfa8 = new DFA8(this);
    static final String dfa_1s = "\24\uffff";
    static final String dfa_2s = "\1\5\2\24\1\5\1\4\6\uffff\1\4\2\42\1\5\2\4\2\42\1\5";
    static final String dfa_3s = "\1\6\2\24\1\40\1\41\6\uffff\1\6\2\42\1\40\1\41\1\6\2\42\1\32";
    static final String dfa_4s = "\5\uffff\1\4\1\2\1\3\1\1\1\6\1\5\11\uffff";
    static final String dfa_5s = "\24\uffff}>";
    static final String[] dfa_6s = {
            "\1\1\1\2",
            "\1\3",
            "\1\3",
            "\2\7\16\uffff\2\10\1\6\1\11\1\12\1\5\5\uffff\1\4",
            "\1\14\1\uffff\1\15\32\uffff\1\13",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\14\1\uffff\1\15",
            "\1\16",
            "\1\16",
            "\2\7\16\uffff\2\10\1\6\2\uffff\1\5\5\uffff\1\17",
            "\1\21\1\uffff\1\22\32\uffff\1\20",
            "\1\21\1\uffff\1\22",
            "\1\23",
            "\1\23",
            "\2\7\16\uffff\2\10\1\6\2\uffff\1\5"
    };

    static final short[] dfa_1 = DFA.unpackEncodedString(dfa_1s);
    static final char[] dfa_2 = DFA.unpackEncodedStringToUnsignedChars(dfa_2s);
    static final char[] dfa_3 = DFA.unpackEncodedStringToUnsignedChars(dfa_3s);
    static final short[] dfa_4 = DFA.unpackEncodedString(dfa_4s);
    static final short[] dfa_5 = DFA.unpackEncodedString(dfa_5s);
    static final short[][] dfa_6 = unpackEncodedStringArray(dfa_6s);

    class DFA8 extends DFA {

        public DFA8(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 8;
            this.eot = dfa_1;
            this.eof = dfa_1;
            this.min = dfa_2;
            this.max = dfa_3;
            this.accept = dfa_4;
            this.special = dfa_5;
            this.transition = dfa_6;
        }
        public String getDescription() {
            return "458:2: (this_Claim_0= ruleClaim | this_Release_1= ruleRelease | this_SimpleAction_2= ruleSimpleAction | this_Move_3= ruleMove | this_RequireEvent_4= ruleRequireEvent | this_RaiseEvent_5= ruleRaiseEvent )";
        }
    }
 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000000001802L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000001002L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000060L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000014000L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000008060L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000001000008060L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000100600000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000000600000L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000100000000L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000100000002L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000100800000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000104000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000000078000000L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000006100000002L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000100000060L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000000200000050L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000001000000060L});

}